c*******************************************************************
c The subroutine gener is designed to generate numerical codes of
c elementary seismic body waves
c
c n          - =0, first entry, =1, secondary;
c is         - source layer; ir - receiver layer;nl - maximal no interface;
c isi        - =1 for p wave, =-1 for s;
c ifin(out)  - =1, finish gener, =-1, kca > 50;
c ncode(out) - internal code; lou - output.
c*******************************************************************
      subroutine gener(n,is,ir,nl,isi,ifin,ncode,lou)
      implicit none
c --- Type definitions ---
      integer*4 i,ifin,ir,is,isi,k,lou,n,ncode,nl
c --- commons ---
      integer*4 jc,kca,kc,idum
      common/cod/jc(50),kca,kc,idum(4)
c ---
      ifin=0
      if(is.le.0.or.is.gt.nl) go to 101
      if(ir.lt.0.or.ir.gt.nl) go to 101
      if(n.eq.0) ncode=0
      ncode=ncode+1
      i=0
      do k=is,nl
        i=i+1
        jc(i)=k*isi
      enddo
      do k=nl,ir,-1
        i=i+1
        jc(i)=k*isi
      enddo
      kca=i
      write(lou,100) kc,kca,(jc(i),i=1,kca)
      return
c Hard error, complete computation
  101 ifin=1
      return
  100 format(24i3)
      end
