c=======================================================
c Subroutine: intf_out 
c Produce contour xxx.xy file for each interface layer
c Used for GMT ptotting of the interface layers
c=======================================================
      subroutine intf_out(iwave)
      implicit none
c ---
      integer*4 n_int,n_intz
      parameter (n_int=20,n_intz=50)
c --- commons -----------------
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c ---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c ---
      integer*4 code,kref,kc,k_beg,k_end,k_step,k_sig
      common/cod/code(50),kref,kc,k_beg,k_end,k_step,k_sig
c ---
      integer*4 numb
      common/number/numb
c ---
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c --- type definitions ---
      real*8    xyint(20,301),xint(301),xa,xb,step,x2,aux,x,z,alph
      real*8    yy(4),v(6)
      integer*4 i,j,jj,k,layer,nc,l1,l2,lnblnk,l3,ii,iwave
      character*160 f_out,digit,digit1
      character*4 phase
c ---
      do layer=1,nint
        nc=npnt(layer)
        xa=x1(1,1)
        xa=-100.0d0
        xb=x1(nc,1)
        step=(xb-xa)/300.0d0
        do j=1,301
          x=xa+(j-1)*step
          do k=1,nc-1
            jj=k
            if(x.lt.x1(k+1,layer)) goto 1
          enddo
    1     x2=x1(jj,layer)
          aux=(x-x2)/(x1(jj+1,layer)-x1(jj,layer))
          z=a1(jj,layer)+(6.0d0*aux*aux-15.0d0*aux+10.0d0)*
     *      aux*aux*aux*(a1(jj+1,layer)-a1(jj,layer))
          if(layer.eq.1) xint(j)=x
          xyint(layer,j)=r0*(1.0d0-dexp(-z/r0))
        enddo
      enddo
      phase='P'
      if(iwave.lt.0) phase='S'
      do i=1,nint-1
        write(digit,'(i2)') i
        l1=1
        if(digit(1:1).eq.' ') l1=2
        l2=lnblnk(sta_name)
        write(digit1,'(i3)') iaz_c
        l3=1
        if(digit1(1:1).eq.' ') l3=2
        if(digit1(2:2).eq.' ') l3=3
        f_out='GRAPH/'//sta_name(1:l2)//'.'//phase(1:1)//'.int.'
     *        //digit1(l3:3)//'.'//digit(l1:2)//'.xy'
        open(14,file=f_out,form='formatted',status='unknown')
        do j=1,301
          alph=xint(j)/r0
          x=(r0-xyint(i,j))*dsin(alph)
          z=(r0-xyint(i,j))*dcos(alph)-r0
          write(14,'(2f10.3)') x,z
        enddo
        do j=301,1,-1
          alph=xint(j)/r0
          x=(r0-xyint(i+1,j))*dsin(alph)
          z=(r0-xyint(i+1,j))*dcos(alph)-r0
          write(14,'(2f10.3)') x,z
        enddo
        close(14)
      enddo
c Plot xyz file for upper mantle layer =====================
      f_out='GRAPH/'//sta_name(1:l2)//'.'//phase(1:1)//'.fld.'
     *        //digit1(l3:3)//'.xyz'
      open(14,file=f_out,form='formatted',status='unknown')
      layer=numb
      layer=6
      nc=npnt(layer)
      lay=layer
      int1=layer
      do i=-100,3001,10
      do ii=1,411,10
      yy(1)=(i-1)*1.0d0
      yy(2)=(ii-1)*1.0d0
      yy(3)=0.0d0
      yy(4)=0.0d0
      itype=isign(1,iwave)
          x=yy(1)
          do k=1,nc-1
            jj=k
            if(x.lt.x1(k+1,layer)) goto 2
          enddo
   2  x2=x1(jj,layer)
      aux=(x-x2)/(x1(jj+1,layer)-x1(jj,layer))
      z=a1(jj,layer)+(6.0d0*aux*aux-15.0d0*aux+10.0d0)*
     *aux*aux*aux*(a1(jj+1,layer)-a1(jj,layer))
      if(yy(2).ge.z) then
        call veloc(yy,v)
          yy(2)=r0*(1.0d0-dexp(-yy(2)/r0))
          alph=yy(1)/r0
          x=(r0-yy(2))*dsin(alph)
          z=(r0-yy(2))*dcos(alph)-r0
          write(14,'(3f11.4)') x,z,v(1)*(r0-yy(2))/r0
      endif
      enddo
      enddo 
      close(14)
      return
      end
c*****************************************************************
c Print information for single ray, arrays: ay(12,n), ds(11,iref)
c*****************************************************************
      subroutine print_ray
      implicit none
c ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      integer*4 ll,il,l
      real*8    xl,zl
      do il=1,iref
       ll=kint(il)
       xl=-999.999d0
       zl=-999.999d0
       if(ll.gt.0) then
        xl=ay(2,ll)
        zl=ay(3,ll)
       endif
       write(*,*) 'AAA',il,ind,ind1,ll,(ds(l,il),l=1,11),xl,zl
      enddo
      do ll=1,n
        write(*,*) 'BBB',ll,(ay(l,ll),l=1,12)
      enddo
      return
      end
c*****************************************************************
c Print single ray in xy format for GMT plotting, 
c arrays: ay(2:3,n)
c*****************************************************************
      subroutine plot_ray(indic,ia,t,xx,zz,aam)
      implicit none
c --- commons -----------------
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer *4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c ---
      integer*4 i_g,i_gg
      real*8    t_min,t_min3,r_max
      common/tbl/i_g,i_gg,t_min(100,11,3),t_min3(100,3),r_max(100,11,3)
c ---
      integer*4   nlayers,net,iwave,igroup(100)
      integer*4   nng,ngrno(100),ngrdev(100)
      real*8      st_rk,dnet
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet,nlayers,iwave,net,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c --- types definition ---
      integer*4 i,indic,ia,nn,igg
      real*8    x,z,alph,xx,zz,aam,t,zzz
c ---
      nn=n
      igg=i_g
      if(indic.eq.1) then
        igg=nng+1
        if(kint(ia).le.0) goto 1
        nn=kint(ia)
      endif
    1 igrc=igrc+1
      zzz=r0*(1.0d0-dexp(-zz/r0))
      write(40+i_g,'("> ",i4,3i3,3f10.3,f12.8)') igrc,ia,ind,ind1,t,xx,zzz,aam
      if(indic.eq.1) write(40+igg,'("> ",i4,3i3,3f10.3,f12.8)') 
     *                     igrc,ia,ind,ind1,t,xx,zzz,aam
      do i=1,nn
      x=ay(2,i)
      z=r0*(1.0d0-dexp(-ay(3,i)/r0))
        alph=x/r0
        x=(r0-z)*dsin(alph)
        z=(r0-z)*dcos(alph)-r0
        write(40+i_g,'(2f10.3)') x,z
        if(indic.eq.1) write(40+igg,'(2f10.3)') x,z
      enddo
      return
      end
