c*******************************************************************
c Read input model: interfaces & velocities from lu device and
c print results on device lou
c*******************************************************************
      subroutine model(lu,lou,mm,mtext)
      implicit none
      integer*4 n_int,n_intz,n_lay,nv_x,nv_z
      parameter (n_int=20,n_intz=50,n_lay=19,nv_x=42,nv_z=50)
c--
c
c     approximation of interfaces and velocity distribution
c     in individual layers (bicubic spline approximation of velocity)
c
c--      
      integer*4 lu,lou,mm
      real*8    bleft,bmax,bmin,bright,vmax,vmin
      integer*4 i,irho,j,l,m1,m2,mi,mx,mx1,mx2,mxy1,
     *mxy2,my,my1,my2,nc,nro
      character*68 mtext 
c-- commons --
      real*8    v,sx,sy,ptos
      integer*4 iptos_d,nx,ny,nvs
      common/medim/v(n_lay*nv_x*nv_z),sx(n_lay*nv_x),sy(n_lay*nv_z),
     *ptos(n_lay),iptos_d,nx(n_lay),ny(n_lay),nvs(n_lay)
c--
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c--
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c--
      real*8    rho1,rho2
      integer*4 nrho
      common/den/rho1(n_lay),rho2(n_lay),nrho
c--
      integer*4 mmx,mmy,mmxy,maux
      common/wauxx/mmx(n_lay),mmy(n_lay),mmxy(n_lay),maux
c--
      real*8    qp1,qp2,qp3,qs1,qs2,qs3
      integer*4 nqp,nqs,nabs
      common/absr/qp1(n_lay),qp2(n_lay),qp3(n_lay),qs1(n_lay),qs2(n_lay),
     *qs3(n_lay),nqp(n_lay),nqs(n_lay),nabs
c--
      mi=0
      if(mm.ne.mi)mm=-1
      if(mm.lt.0)return
c
c     Input data - interfaces
c
      if(mprint.ge.0)write(lou,102)nint,(npnt(i),i=1,nint)
c
      do 11 i=1,nint
      nc=npnt(i)
      if(mprint.ge.0)write(lou,103)(x1(j,i),a1(j,i),iii(j,i),j=1,nc)
c
c     Determination of coefficients of cubic parabolas
c     approximating interfaces
c
   11 continue
c
c     Input data - velocity distribution in individual layers
c
      write(lou,117)
      mx2=0
      my2=0
      mxy2=0
      nc=nint-1
      do 13 i=1,nc
      mx1=mx2+1
      my1=my2+1
      mxy1=mxy2+1
      mx=nx(i)
      my=ny(i)
      if(mprint.ge.0)write(lou,102)mx,my
      mx2=mx1+mx-1
      my2=my1+my-1
      mxy2=mxy1+mx*my-1
      if(mprint.ge.0)write(lou,104)(sx(j),j=mx1,mx2)
      if(mprint.ge.0)write(lou,104)(sy(j),j=my1,my2)
      m1=mxy1
      do 12 l=1,mx
      m2=m1+my-1
      if(mprint.ge.0)write(lou,104)(v(j),j=m1,m2)
   12 m1=m2+1
   13 continue
c
c     Input data - densities and s velocities
c
      nro=0
      nabs=0
      if(mprint.ge.0)write(lou,102)nro,(nvs(i),i=1,nc),nabs
      if(nro.eq.0)go to 30
      read(lu,104)(rho1(i),rho2(i),i=1,nc)
      if(mprint.ge.0)write(lou,104)(rho1(i),rho2(i),i=1,nc)
   30 if(nabs.eq.0)go to 34
      do 35 i=1,nc
      read(lu,106)nqp(i),nqs(i),qp1(i),qp2(i),qp3(i),qs1(i),qs2(i),
     1qs3(i)
      if(mprint.ge.0)write(lou,106)
     1nqp(i),nqs(i),qp1(i),qp2(i),qp3(i),qs1(i),qs2(i),qs3(i)
   35 continue
   34 if(nro.ne.0)go to 31
      do 32 irho=1,nc
      rho1(irho)=1.7d0
      rho2(irho)=.2d0
   32 continue
   31 continue
      if(mprint.ge.0)write(lou,104)(ptos(i),i=1,nc)
      do 33 irho=1,nc
   33 if(ptos(irho).lt.1.41421356d0)ptos(irho)=1.732d0
      if(ptos(1).ge.100.d0)rho1(1)=1.d0
      if(ptos(1).ge.100.d0)rho2(1)=0.d0
      nrho=0
      if(ptos(1).ge.100.d0)nrho=1
c
c     Input data - printer plot of the velocity distribution
c                  x coordinates of vertical boundaries of the model
c
      read(lu,104)vmin,vmax,bmin,bmax,bleft,bright
      if(mprint.ge.0)write(lou,104)vmin,vmax,bmin,bmax,bleft,bright
      if(dabs(bmin).lt..00001d0)bmin=a1(1,1)
      if(dabs(bmax).lt..00001d0)bmax=a1(1,nint)
      if(dabs(bleft-bright).gt..001d0)go to 14
      nc=npnt(1)
      bleft=x1(1,1)
      bright=x1(nc,1)
c
c     numerical form of interfaces
c
  101 format(1h1/17a4)
  102 format(16i5)
  103 format(3(2f10.5,i5))
  104 format(8f10.5)
  105 format(////1x,'M o d e l   o f   m e d i u m'/2x,'number of interf
     1aces - ',i3)
  106 format(2i5,6f10.5)
  107 format(///////1x,'I n t e r f a c e s'///1x,'Interfaces are approx
     1imated by cubic parabolas  z=d*(x-x1)**3+c*(x-x1)**2+b*(x-x1)+a  b
     2etween  x1  and  x2'/1x,'coefficients of parabolas are determined
     3by cubic spline interpolation'///)
  108 format(/1x,'Coefficients of parabolas approximating interface',i3/
     1/15x,'d',14x,'c',14x,'b',14x,'a',2x,'in interval',5x,'from x1',
     27x,'to x2',5x,'index')
  109 format(1x,4e15.5,15x,f10.5,f12.5,i10)
  110 format(////1x,'Numerical form of interface'/1x,'upper row - x-coor
     1dinates of points of interface, lower row - corresponding z-coordi
     2nates of points of interface'//)
  111 format(1x,13f9.4)
  112 format(/)
  113 format(5x,5(f7.3,13x),f7.3)
  114 format(////1x,'Velocity distribution'/1x,'Isolines constructed fro
     1m',f10.5,'  to ',f10.5,'  with increment',f10.5//)
  115 format(1x,f6.2,2x,101i1)
  116 format(9x,101i1)
  117 format(1x,'Bicubic spline interpolation')
c
   14 return
      end
c******************************************************************
c     This subroutine performs the determination of coefficients
c     of the bicubic spline interpolation
c******************************************************************
      subroutine biap(mx1,mx,my1,my,mxy1)
      implicit none
c---
      integer*4 n_lay,nv_x,nv_z
      parameter (n_lay=19,nv_x=42,nv_z=50)
c-- type definitions ---
      integer*4 i,j,k,l,mx,mx1,mxy1,my,my1
      real*8    x(100),fx(100)
c-- common block definitions ---
      real*8    v,sx,sy,ptos
      integer*4 iptos_d,nx,ny,nvs
      common/medim/v(n_lay*nv_x*nv_z),sx(n_lay*nv_x),sy(n_lay*nv_z),
     *ptos(n_lay),iptos_d,nx(n_lay),ny(n_lay),nvs(n_lay)
c---
      real*8    a02,a20,a22
      common/vcoef/a02(n_lay*nv_x*nv_z),a20(n_lay*nv_x*nv_z),
     *a22(n_lay*nv_x*nv_z)
c---
      do 1 j=1,mx
      l=mx1+j-1
    1 x(j)=sx(l)
      do 3 i=1,my
      do 2 j=1,mx
      k=mxy1+(j-1)*my+i-1
    2 fx(j)=v(k)
      call splin(x,fx,1,mx)
      do 3 j=1,mx
      k=mxy1+(j-1)*my+i-1
    3 a20(k)=fx(j)
c
      do 4 i=1,my
      l=my1+i-1
    4 x(i)=sy(l)
      do 6 j=1,mx
      do 5 i=1,my
      k=mxy1+(j-1)*my+i-1
    5 fx(i)=v(k)
      call splin(x,fx,1,my)
      do 6 i=1,my
      k=mxy1+(j-1)*my+i-1
    6 a02(k)=fx(i)
c
      do 7 j=1,mx
      l=mx1+j-1
    7 x(j)=sx(l)
      do 9 i=1,my
      do 8 j=1,mx
      k=mxy1+(j-1)*my+i-1
    8 fx(j)=a02(k)
      call splin(x,fx,1,mx)
      do 9 j=1,mx
      k=mxy1+(j-1)*my+i-1
    9 a22(k)=fx(j)
c
      return
      end
c******************************************************************
c Subroutine veloc determinates  velocity and its derivatives
c for bicubic polynomial approximation
c
c y(1) - x coordinate; y(2) - z coordinate;
c y(3) - >=100.0, write velocities in the ray, < 100.0 don't write
c vel(1) - velocity; vel(2) - dv/dx;    vel(3) - dv/dz;
c vel(4) -d2v/dx2;   vel(5) - d2v/dxdz; vel(6) - d2v/dz2.
c results depend on the next variables:
c maux - should be reset to 0 for the new layer, =1, not calc. spline coeff.
c n - index for current point of the ray ay ( if y(3) >= 100.0)
c lay/auxi/ - layer number, no lay controls for boundaries;
c             contrlol performs for current layer lai, if y is out of
c             layers ind sets to 21,except 1, nint-1 layers, & vel(i) set to 0.
c nder/auxi/ - =0, dont' calculate second derivatives, =1, calculate
c itype/auxi/ - >0 caclulate p velocity, < 0 s velocity
c nabs/absr/ - =0 no absorbtion, !=0 - yes (not used in this version)
c ptos(i)/medim/ - puasson coefficients, <=nint-1
c nvs(i)/medim/ - =0, in memory p velocities, =1, s velocities
c******************************************************************
      subroutine veloc(y,vel)
      implicit none
      integer*4 n_int,n_intz,n_lay,nv_x,nv_z
      parameter (n_int=20,n_intz=50,n_lay=19,nv_x=42,nv_z=50)
      real*8    y(4),vel(6)
c---
      integer*4 i,i1,j,j1,k,mm,mx,my,nq
      real*8    aux1,aux2,aux3,aux4,ax,az,b00,b01,b02,b03,b10,b11,b12,
     *b13,b20,b21,b22,b23,b30,b31,b32,b33,c00,c02,c20,c22,d00,d02,d10,
     *d12,d20,d22,d30,d32,e00,e02,e20,e22,hx,hy,q1,q2,q3,v1,
     *xa,xb,xx,ya,yb,yy
      common/work1/aux1,aux2,aux3,aux4,ax,az,b00,b01,b02,b03,b10,b11,b12,
     *b13,b20,b21,b22,b23,b30,b31,b32,b33,c00,c02,c20,c22,d00,d02,d10,
     *d12,d20,d22,d30,d32,e00,e02,e20,e22,hx,hy,q1,q2,q3,v1,
     *xa,xb,xx,ya,yb,yy,
     *i,i1,j,j1,k,mm,mx,my,nq
c--- commons --
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c---
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c---
      real*8    v,sx,sy,ptos
      integer*4 iptos_d,nx,ny,nvs
      common/medim/v(n_lay*nv_x*nv_z),sx(n_lay*nv_x),sy(n_lay*nv_z),
     *ptos(n_lay),iptos_d,nx(n_lay),ny(n_lay),nvs(n_lay)
c---
      real*8    a02,a20,a22
      common/vcoef/a02(n_lay*nv_x*nv_z),a20(n_lay*nv_x*nv_z),
     *a22(n_lay*nv_x*nv_z)
c---
      integer*4 mmx,mmy,mmxy,maux
      common/wauxx/mmx(n_lay),mmy(n_lay),mmxy(n_lay),maux
c---
      real*8    qp1,qp2,qp3,qs1,qs2,qs3
      integer*4 nqp,nqs,nabs
      common/absr/qp1(n_lay),qp2(n_lay),qp3(n_lay),qs1(n_lay),qs2(n_lay),
     *qs3(n_lay),nqp(n_lay),nqs(n_lay),nabs
c---
      integer*4 i2,j2
      common/work/i2,j2
      mx=nx(lay)
      my=ny(lay)
      do 1 i=2,mx
      k=mmx(lay)+i-1
      if(y(1).lt.sx(k))go to 2
    1 continue
    2 i1=k
      do 3 i=2,my
      k=mmy(lay)+i-1
      if(y(2).lt.sy(k))go to 4
    3 continue
    4 j1=k
      if(maux.eq.0)go to 5
      if(i1.eq.i2.and.j1.eq.j2)go to 6
    5 i=i1-mmx(lay)
      j=j1-mmy(lay)
      i2=i1
      j2=j1
      xx=sx(i1-1)
      yy=sy(j1-1)
      mm=mmxy(lay)-1
      k=mm+(i-1)*my+j
      b20=a20(k)
      b02=a02(k)
      b22=a22(k)
      b00=v(k)
      k=mm+i*my+j
      c20=a20(k)
      c02=a02(k)
      c22=a22(k)
      c00=v(k)
      k=mm+(i-1)*my+j+1
      d20=a20(k)
      d02=a02(k)
      d22=a22(k)
      d00=v(k)
      k=mm+i*my+j+1
      e20=a20(k)
      e02=a02(k)
      e22=a22(k)
      e00=v(k)
      hx=sx(i1)-xx
      hy=sy(j1)-yy
      xa=3.d0*hx
      ya=3.d0*hy
      xb=hx/3.d0
      yb=hy/3.d0
      d32=(e22-d22)/xa
      d30=(e20-d20)/xa
      b30=(c20-b20)/xa
      b32=(c22-b22)/xa
      d12=(e02-d02)/hx-xb*(e22+2.d0*d22)
      d10=(e00-d00)/hx-xb*(e20+2.d0*d20)
      b10=(c00-b00)/hx-xb*(c20+2.d0*b20)
      b12=(c02-b02)/hx-xb*(c22+2.d0*b22)
      b03=(d02-b02)/ya
      b13=(d12-b12)/ya
      b23=(d22-b22)/ya
      b33=(d32-b32)/ya
      b01=(d00-b00)/hy-yb*(d02+2.d0*b02)
      b11=(d10-b10)/hy-yb*(d12+2.d0*b12)
      b21=(d20-b20)/hy-yb*(d22+2.d0*b22)
      b31=(d30-b30)/hy-yb*(d32+2.d0*b32)
      maux=1
    6 ax=y(1)-xx
      az=y(2)-yy
      if(ax.ge.0.d0.and.ax.le.hx.and.az.ge.0.d0.and.az.le.hy)go to 11
      if(az.lt.0.d0.and.lay.ne.1)ind=21
      if(az.gt.hy.and.lay.ne.(nint-1))ind=21
c     Determination of velocity at a point situated
c     outside the velocity network
      do 13 i=2,6
   13 vel(i)=0.d0
      return
   11 aux1=((b33*az+b32)*az+b31)*az+b30
      aux2=((b23*az+b22)*az+b21)*az+b20
      aux3=((b13*az+b12)*az+b11)*az+b10
      aux4=((b03*az+b02)*az+b01)*az+b00
      vel(1)=((aux1*ax+aux2)*ax+aux3)*ax+aux4
      vel(2)=(3.d0*aux1*ax+2.d0*aux2)*ax+aux3
      if(nder.eq.0)go to 7
      vel(4)=6.d0*aux1*ax+2.d0*aux2
    7 aux1=(3.d0*b33*az+2.d0*b32)*az+b31
      aux2=(3.d0*b23*az+2.d0*b22)*az+b21
      aux3=(3.d0*b13*az+2.d0*b12)*az+b11
      aux4=(3.d0*b03*az+2.d0*b02)*az+b01
      vel(3)=((aux1*ax+aux2)*ax+aux3)*ax+aux4
      if(nder.eq.0)go to 8
      vel(5)=(3.d0*aux1*ax+2.d0*aux2)*ax+aux3
      aux1=3.d0*b33*az+b32
      aux2=3.d0*b23*az+b22
      aux3=3.d0*b13*az+b12
      aux4=3.d0*b03*az+b02
      vel(6)=2.d0*(((aux1*ax+aux2)*ax+aux3)*ax+aux4)
    8 if(itype.gt.0.and.nvs(lay).eq.0)go to 10
      if(itype.lt.0.and.nvs(lay).eq.1)go to 10
      if(itype.gt.0.and.nvs(lay).eq.1)go to 9
      if(ptos(lay).ge.100.)go to 12
      vel(1)=vel(1)/ptos(lay)
      vel(2)=vel(2)/ptos(lay)
      vel(3)=vel(3)/ptos(lay)
      if(nder.eq.0)go to 10
      vel(4)=vel(4)/ptos(lay)
      vel(5)=vel(5)/ptos(lay)
      vel(6)=vel(6)/ptos(lay)
      go to 10
   12 vel(1)=0.d0
      vel(2)=0.d0
      vel(3)=0.d0
      if(nder.eq.0)go to 10
      vel(4)=0.d0
      vel(5)=0.d0
      vel(6)=0.d0
      go to 10
    9 vel(1)=ptos(lay)*vel(1)
      vel(2)=ptos(lay)*vel(2)
      vel(3)=ptos(lay)*vel(3)
      if(nder.eq.0)go to 10
      vel(4)=ptos(lay)*vel(4)
      vel(5)=ptos(lay)*vel(5)
      vel(6)=ptos(lay)*vel(6)
   10 if(y(3).lt.100.d0)return
      v1=vel(1)
      ay(6,n)=vel(1)
      ay(7,n)=vel(2)
      ay(8,n)=vel(3)
      if(nder.eq.0)return
      ay(9,n)=vel(4)
      ay(10,n)=vel(5)
      ay(11,n)=vel(6)
      if(nabs.eq.0)return
      if(itype.lt.0)go to 14
      q1=qp1(lay)
      q2=qp2(lay)
      q3=qp3(lay)
      nq=nqp(lay)
      go to 15
   14 q1=qs1(lay)
      q2=qs2(lay)
      q3=qs3(lay)
      nq=nqs(lay)
   15 if(nq.eq.0)ay(12,n)=q1+q2*v1+q3*v1*v1
      if(nq.eq.1)ay(12,n)=q1+q2*v1+q3/v1
      return
      end
c******************************************************************
c
c     Cubic spline interpolation with zero curvatures at
c     the end points
c
c******************************************************************
      subroutine splin(x,fx,nmin,nmax)
      implicit none
c---
      real*8    d1,d2,xpom
      integer*4 i,j,nmax,nmax1,nmin,nmin1
      real*8    a(100),b(100),h(100),f(100),x(100),fx(100)
c---
      if((nmax-nmin).eq.1)go to 4
      nmin1=nmin+1
      nmax1=nmax-1
      h(nmin1)=x(nmin1)-x(nmin)
      d2=(fx(nmin1)-fx(nmin))/h(nmin1)
      do 1 i=nmin1,nmax1
      h(i+1)=x(i+1)-x(i)
      d1=d2
      d2=(fx(i+1)-fx(i))/h(i+1)
      b(i)=h(i)+h(i+1)
      fx(i)=3.d0*(d2-d1)/b(i)
      a(i)=h(i)/b(i)
    1 b(i)=h(i+1)/b(i)
    4 fx(nmin)=0.d0
      fx(nmax)=0.d0
      if((nmax-nmin).eq.1)return
      h(nmin)=0.d0
      f(nmin)=0.d0
      do 2 i=nmin1,nmax1
      xpom=2.d0+a(i)*h(i-1)
      h(i)=-b(i)/xpom
    2 f(i)=(fx(i)-a(i)*f(i-1))/xpom
      do 3 i=nmin,nmax1
      j=nmax1-(i-nmin)
    3 fx(j)=h(j)*fx(j+1)+f(j)
      return
      end
