c============================================================
c Transformation 2d profile from sphere to plain and
c data construction for the ray tracing subroutine seis.
c============================================================
      subroutine psinp(iwave,im,iv,n_lay1,dnet,take_off,nnlay)
      implicit none
c ---
      integer*4 n_int,n_intz,n_lay,nv_x,nv_z
      parameter (n_int=20,n_intz=50,n_lay=19,nv_x=42,nv_z=50)
c --- Common block's definition ---
      real*8    a1,b1,c1,d1,xx,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),xx(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c ---
      integer*4 mmx,mmy,mmxy,maux
      common/wauxx/mmx(n_lay),mmy(n_lay),mmxy(n_lay),maux
c ---
      real*8    v,sx,sy,ptos
      integer*4 iptos_d,nx,ny,nvs
      common/medim/v(n_lay*nv_x*nv_z),sx(n_lay*nv_x),sy(n_lay*nv_z),
     *ptos(n_lay),iptos_d,nx(n_lay),ny(n_lay),nvs(n_lay)
c ---
      integer*4 iwave,m,nn(100),ind(101,100,2)
      real*8    delta,mod(101,100,2),ff(100),fl(100)
      common/mod2/delta,mod,ff,fl,nn,ind,m
c --- 
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      real*8    take_off(20)
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c ---
      integer*4   nlayers1,net1,iwave1,igroup(100)
      integer*4         nng,ngrno(100),ngrdev(100)
      real*8    st_rk,dnet1
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet1,nlayers1,iwave1,net1,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c --- types definition ---
      real*8    modp(101,100,2),x(100)
      integer*4 i,i_i,i_n,ic,im,iv,j,jbb,je,k,kl,n,n_lay1,nnlay
      real*8    slip,step,xini,zmax,zmin,zz,dnet
      real*8    x0,y0,z0,x1,y1,z1,vel_0,vel_i,dxx,fl_c,ddx
      character*68 title
      character*160 cmd
c ---
      real*8    hh1,g_x(100),g_xx(100),g_y(100),g_yy(100)
      integer*4 k1,k_g,iflag
c ---
      integer*4 m1,m2,mx,mx1,mx2,mxy1,mxy2,my,my1,my2
c ---
c Flattering spherical model to plain =========================
c x=r0*del, z=r0*ln(ro/r), v=v*exp(z/r0) ====================
c ---
      xini=0.0d0
      fl_c=datan(geo*dtan(rad*ff(1)))/rad
c --- ff(1)
      x0=dcos(fl(1)*rad)*dcos(fl_c*rad)
      y0=dsin(fl(1)*rad)*dcos(fl_c*rad)
      z0=dsin(fl_c*rad)
      dxx=-dnet*rad*r0
      do 2 i=1,m
      fl_c=datan(geo*dtan(rad*ff(i)))/rad
      x1=dcos(fl(i)*rad)*dcos(fl_c*rad)
      y1=dsin(fl(i)*rad)*dcos(fl_c*rad)
      z1=dsin(fl_c*rad)
      ddx=x0*x1+y0*y1+z0*z1
      if(ddx.gt.1.0d0) ddx=1.0d0
      x(i)=r0*dacos(ddx)+dxx
      if(i.eq.2) x(i)=0.0d0
      do 3 j=1,n_lay1
      modp(j,i,1)=r0*dlog(r0/(r0-mod(j,i,1)))
      modp(j,i,2)=mod(j,i,2)*dexp(modp(j,i,im)/r0)
    3 continue
    2 continue
c Set up starting counters for packing velocities =====
      mx2=0
      my2=0
      mxy2=0
c Prepare input for ray tracer ===============================
      i_n=0
      vel_0=modp(1,1,2)
      ic=0
      jbb=1
   28 je=jbb+1
   27 if(ind(je,1,2).lt.0) goto 26
      je=je+1
      goto 27
   26 n=je-jbb+1
      zmin=r0
      zmax=-30.0d0
c
c Bispline interpolation velocity layer
c
      iflag=0
      if(n.eq.2) iflag=1
      if(n.eq.2) n=n+2
c  Write distances  ===========================
      mx1=mx2+1
      my1=my2+1
      mxy1=mxy2+1
      mx=m
      my=n
      nx(ic+1)=mx
      ny(ic+1)=my
      mx2=mx1+mx-1
      my2=my1+my-1
      mxy2=mxy1+mx*my-1
      do j=mx1,mx2
        sx(j)=x(j-mx1+1)
      enddo
      if(iflag.eq.0) then
c
c A lot of interface layers ==============================
c
        do 14 k=1,m
        do 14 kl=jbb,je
        zz=modp(kl,k,im)  
        if(zz.lt.zmin) zmin=zz
        if(zz.gt.zmax) zmax=zz
   14   continue
c Compute take off angles for the first ray ===============
        i_n=i_n+1
        if(iaz_i.eq.iaz_c) then
          take_off(i_n)=-10.0d0
          vel_i=vel_0/modp(jbb+1,1,2)
          if(vel_i.lt.1.0d0) take_off(i_n)=dacos(vel_i)
        endif
        zmax=zmax+5.0d0
        zmin=zmin-5.0d0
      else
c
c Only 2 interface layers =====  =========================
c
        do k=1,m
          do kl=jbb,je
            zz=modp(kl,k,im)  
            if(zz.lt.zmin) zmin=zz
            if(zz.gt.zmax) zmax=zz
          enddo
        enddo
c Compute take off angles for the first ray ===============
        i_n=i_n+1
        if(iaz_i.eq.iaz_c) then
          take_off(i_n)=-10.0d0
          vel_i=vel_0/modp(jbb+1,1,2)
          if(vel_i.lt.1.0d0) take_off(i_n)=dacos(vel_i)
        endif
        zmin=zmin-5.0d0
        zmax=zmax+5.0d0
      endif
      step=(zmax-zmin)/(n-1)
      do k=1,n
         g_xx(k)=zmin+step*(k-1)
      enddo
c Write depthes ================================
      do j=my1,my2
        sy(j)=g_xx(j-my1+1)
      enddo
      m1=mxy1
c ---
c Main loop ============
c ---
      do k=1,m
        if(iflag.eq.0) then
          do j=1,n
            k1=jbb-1+j
            g_x(j)=modp(k1,k,im)
            g_y(j)=modp(k1,k,iv)
          enddo
        else
          g_x(1)=zmin
          g_x(4)=zmax
          g_x(2)=modp(jbb,k,im)
          g_x(3)=modp(je ,k,im)
          g_y(2)=modp(jbb,k,iv)
          g_y(3)=modp(je ,k,iv)
          slip=g_x(3)-g_x(2)
          if(dabs(slip).lt.0.0001) then
            slip=0.0d0
          else
            slip=(g_y(3)-g_y(2))/slip
          endif
          g_y(1)=g_y(2)-5.0d0*slip
          g_y(4)=g_y(3)+5.0d0*slip
        endif
c Interpolation velocities for regular grid by depth
        k_g=1
        do j=1,n
          if(g_xx(j).lt.g_x(1).and.iflag.eq.0) then
            g_yy(j)=g_y(1)
            goto 18
          endif
   16     hh1=g_x(k_g+1)-g_xx(j)
          if(hh1.ge.0.0d0.or.(k_g+1).eq.n) goto 17
          k_g=k_g+1
          goto 16
   17     g_yy(j)=g_y(k_g+1)-hh1/(g_x(k_g+1)-g_x(k_g))*(g_y(k_g+1)-g_y(k_g))
   18     continue
        enddo
c Pack velocities ========================
        m2=m1+my-1
        do j=m1,m2
         v(j)=g_yy(j-m1+1)
        enddo
        m1=m2+1
      enddo
c
c     Determination of coefficients of bicubic parabolas
c     approximating velocity distribution
c
      call biap(mx1,mx,my1,my,mxy1)
      mmx(ic+1)=mx1
      mmy(ic+1)=my1
      mmxy(ic+1)=mxy1
c ---
      ic=ic+1
c Write interfaces in common for seis88 =================
      do j=1,m
        xx(j,ic)=x(j)
        a1(j,ic)=modp(jbb,j,im)
        iii(j,ic)=0
      enddo
c
c End of layer
c
      jbb=je+1
      if(jbb.lt.n_lay1) goto 28
      do j=1,m
        xx(j,ic+1)=x(j)
        a1(j,ic+1)=modp(je,j,im)
       iii(j,ic+1)=0
      enddo
c Group #2: Interfaces data
c ================================
      nint=ic+1
      do j=1,ic+1
        npnt(j)=m
      enddo
c parameters part 
      cmd='tmp.'//spid(1:npid)//'.seis.data'
      open(15,file=cmd,form='formatted',status='unknown')
c Group #1: Header: field3 - mprint
c ==================================
      title='Input Data'
      write(15,'(3i2,a68,2x,2i2)') 0,2,0,title,0,0
c Group #3: Puasson coefficients and P/S conversations
c ====================================================
      do j=1,ic
        nvs(j)=(1-iwave)/2
      enddo
c ---
      do j=1,ic
        ptos(j)=1.8
      enddo
c --- End ----
      write(15,'(8f10.5)')  2.,4. 
c                       icont mep mout mdim method ibp ibs iup ius idp ids
      write(15,'(20i3)')    1,  2,   1,   0,     2,  0,  0,  0,  0,  0, 0,
     *                      1,   1,    0,   0,  1,  2,    0,  2,   0
c                       iread mreg itmax nlay lu1 lu2 ltape ksh iloc
      write(15,'(8f10.5)') xini,100.000,1.2
      write(15,'(8f10.5)') 0.0,0.,0.,0.05,0.,0.,0. 
      write(15,'(8f10.5)') 
     *st_rk*(3.0d0-dble(iwave)),1.57078, -.0002,0.5,.001,.001,1.56,.00001 
c
      i_i=2
      write(15,'(24i3)') 1,i_i,1,nnlay,1,iwave
      write(15,'(8f10.5)') 
      write(15,'(8f10.5)') 
      close(15)
      call seis88(i_n,take_off)
      end
