c===========================================================
c Module read_model reads input 3-D model and check it for 
c the constant number of layer and constant number of knots
c inside each layer at each geographical point. 
c Model stores in common block /modcu/.
c===========================================================
      subroutine read_model(iwave,net)
      implicit none
c --- Common block definitions ---
      integer*4 nlayers,npoints,mnn(43000),mind(100,43000,2),
     *          itab(179,361)
      real*8    gff(43000),gfl(43000)
      real*4    gmod(100,43000,2)
      common/modcu/ nlayers,npoints,gff,gfl,gmod,mnn,itab,mind
c ---
      character*160 model_cu,model_iasp,out_dir
      common/fnames/ model_cu,model_iasp,out_dir
c --- Type definitions
      integer*4 mindi(100,2)
      integer*4 i,iif,iil,j,jj,i_lay,iwave,l,net,idum,idum1
      real*8    gmodi(100,3)
c ---
c Clear auxilary index itab ==========
      do i=1,179
      do j=1,361
        itab(i,j)=0
      enddo
      enddo
c Read model =================
      open(7,file=model_cu,form='formatted',status='old')
      i=0
    2 i=i+1
c ---
c  gff(i),gfl(i) - geographical latitude & longitude (deg),
c  mnn(i)        - number of knots
c ---
    3 read(7,*,end=99) gff(i),gfl(i),mnn(i)
      if(mnn(i).gt.100) then
        write(*,'("(E004) Too much knots,",i5," at point:",2f10.4)') 
     *       mnn(i),gff(i),gfl(i)
        stop
      endif
      iif= gff(i) +90.5d0
      iil= gfl(i) +1.5d0
      itab(iif,iil)=i
      if(iil.eq.1) itab(iif,361)=i
c Read vertical profile =================================
c ---
c  idum, idum1 - dummy variables, add its according input format
c  gmodi(jj,1) - knot depth, (km),
c  gmodi(jj,2) - vp velocity, (km/s)
c  gmodi(jj,3) - vs velocity, (km/s)
c ---
      do jj=1,mnn(i)
        read(7,*,end=999) idum,idum1,(gmodi(jj,l),l=1,3)
        mindi(jj,1)=jj
        mindi(jj,2)=0
      enddo
      if(net.eq.2.and.(mod(iif,2).eq.1.or.mod(iil,2).eq.0)) then
          itab(iif,iil)=0
          goto 3
      endif
c Check model consistensy ==========================
      i_lay=1
      mindi(1,2)=1
      do jj=1,mnn(i)-1
        if(abs(gmodi(jj+1,1)-gmodi(jj,1)).gt.5.0e-5) then
          mindi(jj,2)=i_lay
c       else if(abs(gmodi(jj+1,2)-gmodi(jj,2)).gt.5.0e-5.or.
c    *          abs(gmodi(jj+1,3)-gmodi(jj,3)).gt.5.0e-5) then
        else
          mindi(jj,2)= -i_lay
          i_lay=i_lay+1
c       else if(jj.gt.2.and.mindi(jj-1,2).lt.0) then
c         mindi(jj,2)=i_lay
        endif
      enddo
      if(i_lay.ne. nlayers) then
         write(*,1000) i_lay,gff(i),gfl(i),nlayers
         do l=1,mnn(i)
           write(*,*) mindi(l,1),mindi(l,2),gmodi(l,1),gmodi(l,2),gmodi(l,3)
         enddo
         stop
      endif
      j=mnn(i)
      mindi(j,2)= -i_lay
c Store model in common /modcu/ =================================
      j=0
      do jj=1,mnn(i)
        if(mindi(jj,2).ne.0) then
          j=j+1
          mind(j,i,1)=j
          mind(j,i,2)=mindi(jj,2)
          gmod(j,i,1)=gmodi(jj,1)
          if(iwave.lt.0) then
            gmod(j,i,2)=gmodi(jj,3)
          else
            gmod(j,i,2)=gmodi(jj,2)
          endif
        endif
      enddo
      mnn(i)=j
      goto 2
   99 close(7)
      npoints=i-1
      call lay_info
      return
  999 write(*,'("(E002) Unexpected end of model file at point:",2f8.2)')
     *        gff(i),gfl(i)
      stop
 1000 format("(E001) Wrong number of layers",i2," at point:",2f8.2,
     *        ", should be: ",i2)
      end
c===========================================================
c Test
c --- Common block definitions ---
c      integer*4 nlayers,npoints,mnn(43000),mind(100,43000,2),
c     *          itab(179,361)
c      real*8    gff(43000),gfl(43000)
c      real*4    gmod(100,43000,2)
c      common/modcu/ nlayers,npoints,gff,gfl,gmod,mnn,itab,mind
cc --- Type definitions
c      character*160 file_in
cc ---
c      nlayers=8
c      iwave=1
c      file_in='../../model/CUB1.0.raytracer.asc'
c      call read_model(file_in,iwave,net)
c      do i=1,npoints
c        write(*,*) gff(i),gfl(i),mnn(i)
cc        do jj=1,mnn(i)
cc           write(*,*) (mind(jj,i,l),l=1,2),(gmod(jj,i,l),l=1,2)
cc        enddo
c      enddo
c      end
