C====================================================
c  Ray tracing for round the corner rays for 6 layer
c====================================================
      subroutine refract(i_a,dt,ac,tmax)
      implicit none
c ---
      integer*4 n_int,n_intz,n_lay
      parameter (n_int=20,n_intz=50,n_lay=19)
c ---
      real*8    y(4),a2,x2,hh,au,xsour,dzsour,step1,zsour_old,zsour1
      real*8    vel(6),aam,zsour,tsour,x,z,t,fi,dt,ac,tmax
      real*8    xsta,xend,v1,v11,v2,del1,del2,tim1,tim2,step,vint
      integer*4 i,i1,i2,nl,j,nsta,nend,n_1,i_i
      integer*4 il,i_a,nn,isi,isi1,nk(11)
      real*8    de(11),ti(11),ro(11)
      real*8    de1(11),ti1(11),ro1(11)
      real*8    e_z1,e_z2,e_x1,e_x2,e_t1,e_t2,e_zc,e_xc,e_tc,r_max2
      real*8    ttm,ttr,dd3,dd4,tt3,tt4,rr3,rr4,ddm
c --- commons -----------------
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      integer*4 i_g,i_gg
      real*8    t_min,t_min3,r_max
      common/tbl/i_g,i_gg,t_min(100,11,3),t_min3(100,3),r_max(100,11,3)
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c ---
      integer*4 code,kref,kc,k_beg,k_end,k_step,k_sig
      common/cod/code(50),kref,kc,k_beg,k_end,k_step,k_sig
c ---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c ---
      integer*4 codes(50),krefs,kcs
c Print main tables ===================
      if(i_a.eq.1) return
      if(kint(i_a-1).le.0) then
         call print_ray
         stop '(E995) NO info aboit DS'
      endif
      nsta=kint(i_a-1)
      if(kint(iref-i_a+1).le.0) then
         call print_ray
         stop '(E995) NO info aboit DS'
      endif
      nend=kint(iref-i_a+1)
      xsta=ay(2,nsta)
      xend=ay(2,nend)
c  Save old and set new schema ===============================
      krefs=kref
      kcs=kc
      do i=1,50
         codes(i)=code(i)
      enddo
c New schema ---------------------
      itype=isign(1,code(1))
      kc=-1
      kref=i_a-1
      do il=kref,1,-1
        code(kref-il+1)=il*itype
      enddo
      if(kref.eq.1) then
         kc=0
         code(1)=1*itype
         code(2)=1*itype
         kref=2
      endif
      if(idbg.gt.0) write(*,'(a4,3x,i3,16i4)') 'code',kc,(code(il),il=1,kref)
      ind=i_a-1
      n_1=kint(i_a-1)
      tsour=ay(1,n_1)
      xsour=ay(2,n_1)
      step=4.0d0
      del2=9999.999d0
c Main loop ================================
      i_i=0
      isi=0
      vint=tsour
   10 if(i_i.ne.0) xsour=xsour+step
      if(xsour.gt.2458.0d0) goto 9
cxx   if(i_a.eq.3) call print_ray
c starting angle is atan(dy/dx) along interface ====
      intr=i_a
      nl=npnt(intr)-1
      do 2 i=1,nl
      j=i
      if(xsour.lt.x1(i+1,intr)) goto 3
    2 continue
    3 continue
      a2=a1(j,intr)
      x2=x1(j,intr)
      hh=x1(j+1,intr)-x2
      au=(xsour-x2)/hh
      zsour=a2+(6.0d0*au*au-15.0d0*au+10.0d0)*
     xau*au*au*(a1(j+1,intr)-a2)
      dzsour=30.0d0*(au-1.0d0)*(au-1.0d0)*au*au*(a1(j+1,intr)-a2)/hh
      aam=datan(dzsour)
cxx   if(i_a.eq.3) write(*,*) aam,tsour,xsour,zsour
c estimate velocity of the bottom layer
        y(1)=xsour     
        y(2)=zsour     
        y(3)=0.d0
        y(4)=0.d0
        itype=isign(1,code(1))
        lay=i_a
        call veloc(y,vel)
        v2=vel(1)
c estimate velocity of the top layer
        y(1)=xsour     
        y(2)=zsour     
        y(3)=0.d0
        y(4)=0.d0
        itype=isign(1,code(1))
        lay=i_a-1
        call veloc(y,vel)
        v11=vel(1)
        if(dabs(v2-v11).lt.0.00005d0.or.v11.gt.v2) goto 9
cxx     write(*,*) 'VEL',v11,v2
        aam=aam-dacos(v11/v2)
c accumulate time along interface
        if(i_i.eq.0) v1=v2
        step1=dsqrt(step*step+(zsour_old-zsour)*(zsour_old-zsour))
        if(i_i.ne.0)vint=vint+(1.0d0/v1+1.0d0/v2)*step/2.0d0
      n_1=n_1+1
      ay(1,n_1)=vint
      ay(2,n_1)=xsour
      ay(3,n_1)=zsour
      tsour=ay(1,n_1)
      nn=n_1
c
      ind=i_a-1
      zsour1=zsour-0.005d0
      call ray3(xsour,zsour1,tsour,aam,x,z,t,fi,tmax,dt,ac,nn)
cxx   write(*,*) 'ray3',xsour,zsour,tsour,aam,x,z,t
cxx   write(*,*) 'end',i_a,ind,aam,ay(1,n),ay(2,n),ay(3,n)
cxx   if(i_a.eq.3) call print_ray
      if(ind.eq.3) goto 8
c Filling delta,time,r_max arrays
      isi=0
      v1=v2
      zsour_old=zsour
      i_i=i_i+1
      goto 10
   8  r_max2=-30.0d0
      do i=1,nhs+1
        nk(i)=0
        de(i)=9999.999d0
        ro(i)=9999.999d0
        ti(i)=9999.999d0
      enddo
      do i=n,2,-1
          e_z1=ay(3,i-1)
          e_z2=ay(3,i)
          e_x1=ay(2,i-1)
          e_x2=ay(2,i)
          e_t1=ay(1,i-1)
          e_t2=ay(1,i)
        do j=3,nhs+1
          e_zc=h(j-1)
          if(e_zc.gt.e_z2.and.e_zc.le.e_z1) then
            if(nk(j).gt.0) goto 667
            nk(j)=nk(j)+1
            if(dabs(e_z2-e_z1).lt.1.0e-8) then
             e_xc=(e_x2+e_x1)/2.0d0
            else
             e_xc=(e_x2-e_x1)/(e_z2-e_z1)*(h(j-1)-e_z1)+e_x1
            endif
            de(j)=e_xc
            if(dabs(e_x2-e_x1).lt.1.0e-8) then
             e_tc=(e_t2+e_t1)/2.0d0
            else
             e_tc=(e_t2-e_t1)/(e_x2-e_x1)*(e_xc-e_x1)+e_t1
            endif
            ti(j)=e_tc
          endif
  667   continue
        enddo
        if(e_z2.gt.r_max2) r_max2=e_z2
      enddo
      ti(1)=ay(1,n)
      de(1)=ay(2,n)
cxx   ll=kint(iref-2)
      ti(2)=0.0d0
      de(2)=0.0d0
      do j=1,nhs+1
        if(de(j).lt.9998.999d0) ro(j)=r_max2
      enddo
c Print main tables ===================
      if(idbg.gt.0) write(*,*)'refr_ray',ind,ind1,i_i,t,x,z,xsour,zsour
c Initial velocity ================
      if(i_i.eq.0) then
        del1=ay(2,n)
        tim1=ay(1,n)
        do i=1,nhs+1
          de1(i)=de(i)
          ti1(i)=ti(i)
          ro1(i)=ro(i)
        enddo
        v1=v2
        zsour_old=zsour
        i_i=i_i+1
        goto 10
      endif
c Current velocity ================
      del2=x
      tim2=t 
c* Construct times with regular step ==================
      if(del2.gt.del1) isi1=1
      if(del2.lt.del1) isi1=-1
      if(dabs(del2-del1).lt.0.005d0) isi1=0 
      if(dabs(del2-del1).gt.50.0d0) isi1=0 
      if(isi1.eq.0) then
        isi=0
        goto 66
      endif
      if(isi.eq.0) then
        isi=isi1
      goto 666
      endif
      if(isi.ne.isi1) then
         isi=isi1
      goto 66
      endif
c* filling times =========================
  666 continue
      do 669 j=1,nhs+1
      if(ti1(j).gt.9998.999d0.or.ti(j).gt.9998.999d0) goto 669
      if(de1(j).lt.de(j)) then
        dd3=de1(j)
        dd4=de(j)
        tt3=ti1(j)
        tt4=ti(j)
        rr3=ro1(j)
        rr4=ro(j)
      else
        dd4=de1(j)
        dd3=de(j)
        tt4=ti1(j)
        tt3=ti(j)
        rr4=ro1(j)
        rr3=ro(j)
      endif
      i1=dd3/25.0d0
      i2=dd4/25.0d0
      if(i2.gt.max_delta+1) goto 669
      do i=i1,i2
      ddm=dble(i)*25.0d0
        if(dd3.le.ddm.and.ddm.le.dd4) then
          ttm=(tt4-tt3)*(ddm-dd3)/(dd4-dd3)+tt3
          ttr=(rr4-rr3)*(ddm-dd3)/(dd4-dd3)+rr3
          if(j.eq.2.and.dabs(t_min3(i+1,i_g)).gt.ttm) t_min3(i+1,i_g)=-ttm
          if(j.ne.2.and.dabs(t_min(i+1,j,i_g)).gt.ttm) then
               t_min(i+1,j,i_g)=-ttm
               r_max(i+1,j,i_g)=ttr
          endif
        endif
      enddo
 669  continue
c Saving old values ============
  66    do i=1,nhs+1
          de1(i)=de(i)
          ti1(i)=ti(i)
          ro1(i)=ro(i)
        enddo
      v1=v2
      del1=del2
      tim1=tim2
      zsour_old=zsour
      i_i=i_i+1
      goto 10
c Restore old scheme ================
   9  continue
      kref=krefs
      kc=kcs
      do i=1,50
         code(i)=codes(i)
      enddo
      return
      end
