c*********************************************************************
c     root subroutine designed for determination of the point of
c     incidence at an interface, e.g., intersection of the ray 
c     with the interface). Completely new code based on half
c     division method.
c*********************************************************************
      subroutine root(yold,ynew,yint,anyx,anyz,rc,j,iroot)
      implicit none
c --- common's ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      real*8    yold(2),ynew(4),yint(2),anyx,anyz,rc
      real*8    x0,x1,xc,y0,y1,dy,dsy,dx,dd,aux,aux1,aux2
      real*8    ys0,ys1,hh_n,ff_n,x2,yc,ysc,stu
      integer*4 j,iroot,nnn
c ---
      iroot=100
      x0=yold(1)
      x1=ynew(1)
c Difference of argumens is too small ==========
      if(dabs(x0-x1).lt.1.0d-8) then
        xc=(x0+x1)/2.0d0
        goto 8
      endif
      y0=yold(2)
      y1=ynew(2)
      call getint(x0,ys0,hh_n,ff_n,x2,j)
      call getint(x1,ys1,hh_n,ff_n,x2,j)
c Check left boundary for root ================
      if(dabs(y0-ys0).lt.1.0d-10) then
        xc=x0
        goto 8
      endif
c Check right boundary for root ================
      if(dabs(y1-ys1).lt.1.0d-10) then
        xc=x1
        goto 8
      endif
c Check for different sign at both boundaries =====
      if((y0-ys0)*(y1-ys1).gt.0.0d0) then
        yint(1)=(x0+x1)/2.0d0
        call getint(yint(1),yint(2),hh_n,ff_n,x2,j)
        write(*,*) '(W660) Root not found: x=',x0,',z=',y0
        write(*,*) x1,y1,ys0,ys1
        write(*,*) 'YINT',yint
        goto 8
      endif
c Half division method ====
   1  xc=(x1+x0)/2.0
      yc=(y1+y0)/2.0
      if(dabs(x1-x0).lt.1.0e-4) goto 7
      call getint(xc,ysc,hh_n,ff_n,x2,j)
      if((y0-ys0)*(yc-ysc).lt.0.0d0) then
        ys1=ysc
        x1=xc
        y1=yc
        goto 1
      else
        ys0=ysc
        x0=xc
        y0=yc
        goto 1
      endif
c The final linear approximation ===========
    7 dy=y1-y0
      dsy=ys1-ys0
      dd=dy-dsy
      dx=x1-x0
      xc=dx*dsy/dd+x0
      if(xc.gt.x1.or.xc.lt.x0) xc=(x0+x1)/2.0d0
c Check for stupid 28 parameter ====
    8 yint(1)=xc
      if(iref.eq.1)go to 6
      nnn=kint(iref-1)
      if(nnn.le.0)go to 6
      stu=yint(1)-ay(2,nnn)
      if(dabs(stu).le..000015d0) then
        if(stu.ge.0.0d0) yint(1)=yint(1)+1.0e-4
        if(stu.lt.0.0d0) yint(1)=yint(1)-1.0e-4
      endif
    6 call getint(yint(1),yint(2),hh_n,ff_n,x2,j)
c ---
      aux=(yint(1)-x2)/hh_n
      aux1=30.0d0*(1.0d0*aux*aux-2.0d0*aux+1.0d0)*
     *aux*aux*ff_n/hh_n
      aux2=1.d0/(aux1*aux1+1.d0)
      aux2=dsqrt(aux2)
      anyx=-aux1*aux2
      anyz=aux2
c---
      rc=60.0d0*(2.0d0*aux*aux-3.0d0*aux+1.0d0)*
     *aux*ff_n/hh_n/hh_n
      rc=rc*anyz*anyz*anyz
      return
      end
c=====================================================================
c getint computes interface value y for point x, dh, df - argument and
c value increment of interface grid, j - auxilary index
c=====================================================================
      subroutine getint(x,y,dh,df,x3,j)
      implicit none
c ---
      integer*4 n_int,n_intz
      parameter (n_int=20,n_intz=50)
c ---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c ---
      real*8    a1,b1,c1,d1,x1,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),x1(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c ---
      integer*4 nl,i,j
      real*8    aux,y,x2,x,dh,df,x3
c ---
      nl=npnt(intr)-1
      if(j.lt.1) then
        j=1
        goto 1
      endif
      if(j.gt.nl) then
        j=nl
        goto 1
      endif
      if(x1(j,intr).le.x.and.x.lt.x1(j+1,intr)) goto 3
    1 do 2 i=1,nl
      j=i
      if(x.lt.x1(i+1,intr)) goto 3
    2 continue
    3 x2=x1(j,intr)
      aux=(x-x2)/(x1(j+1,intr)-x1(j,intr))
      y=a1(j,intr)+(6.0d0*aux*aux-15.0d0*aux+10.0d0)*
     *aux*aux*aux*(a1(j+1,intr)-a1(j,intr))
      dh=x1(j+1,intr)-x1(j,intr)
      df=a1(j+1,intr)-a1(j,intr)
      x3=x1(j,intr)
      return
      end
