c========================================================
c set_defaults module sets parameters for D2tracerdn
c program from standalone flat file. If parameter file
c doesn't exists default values are assumed.
c They are correspond to CUB1.0 with 2x2 grid cell. 
c========================================================
      subroutine set_defaults(file_def,wavet,m_name)
      implicit none
c --- Common blocks ---
      integer*4   nlayers,net,iwave,igroup(100)
      integer*4   nng,ngrno(100),ngrdev(100)
      real*8      st_rk,dnet
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet,nlayers,iwave,net,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c ---
      integer*4 numb
      common/number/numb
c ---
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      character*160 model_cu,model_iasp,out_dir
      common/fnames/ model_cu,model_iasp,out_dir
c --- common block definitions ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c --- Local variables ---
      logical ex
      character*160 file_def,cmd,pname
      integer*4 i,j,jj,l,l1,lnblnk,isw,iflag,ieq,ieb
      integer*4 lay_ind,igr,ieq1,ndg1,ndg2
      character*8 t_pn,t_sn,m_name
      character*20 wavet,sdig,coord
      character*1 t_w,t_h
      real*8 delta_max
c ---
c
c Set default values ======================================
c
      nlayers=8
      do i=1,100
        igroup(i)=-100
      enddo
      st_rk=0.1d0
      net=2
      dnet=2.0d0
      wavet='P'
      iwave=1
      nhs=6
      do i =1,6
        hs(i)=(i-1)*10.0d0
      enddo
c more default values
      m_name='CUB10'
      igeoc=1
      coord='geogr'
      sta_name='FRU'
      surr_name='AAK'
      sfi=42.637
      slam=74.620
      elev=0.830
      igraph=0
      idbg=0
      iaz_i=0
      iaz_e=357
      iaz_st=3
      delta_max=20.0d0
      max_delta=(delta_max*rad*R0)/25.0d0+2.d0
c ---
      model_cu='.'
      model_iasp='.'
      out_dir='.'
      igroup(1)=1
      igroup(2)=1
      igroup(3)=1
      igroup(4)=1
      igroup(5)=1
      igroup(6)=2
      igroup(7)=3
      igroup(8)=3
      p_phname(1)='Pg'
      p_phname(2)='Pg'
      p_phname(3)='Pg'
      p_phname(4)='Pg'
      p_phname(5)='Pg'
      p_phname(6)='Pn'
      p_phname(7)='P'
      p_phname(8)='P'
      s_phname(1)='Lg'
      s_phname(2)='Lg'
      s_phname(3)='Lg'
      s_phname(4)='Lg'
      s_phname(5)='Lg'
      s_phname(6)='Sn'
      s_phname(7)='S'
      s_phname(8)='S'
      c_wave(1)='Y'
      c_wave(2)='Y'
      c_wave(3)='Y'
      c_wave(4)='Y'
      c_wave(5)='N'
      c_wave(6)='Y'
      c_wave(7)='Y'
      c_wave(8)='Y'
      c_head(1)='N'
      c_head(2)='N'
      c_head(3)='N'
      c_head(4)='N'
      c_head(5)='N'
      c_head(6)='Y'
      c_head(7)='N'
      c_head(8)='N'
      tables='SSSC'
      model_cu='../model/CUB1.0.raytracer.f.asc'
      model_iasp='../model/IASP91_TBL'
      out_dir='.'
c test for presence parameter file ==============
      inquire(file=file_def,exist=ex)
      if(ex.eqv..false.) then
        l=lnblnk(file_def)
        write(*,1000) file_def(1:l)
      write(*,1030) 
 1030 format('(I011) Default parameter file:',/,'Contents:')
        goto 999
      endif
c
c translate parameter file =====================
c
      do i=1,100
        igroup(i)=-100
      enddo
      open(7,file=file_def,status='old')
c read record and clean comments =========
        isw=0
    1   cmd=' '
        iflag=0
        ieq=0
        read(7,'(a160)',end=99) cmd
        do i=1,160
          if(cmd(i:i).eq.'#') iflag=1
          if(iflag.eq.1) cmd(i:i)=' '
          if(cmd(i:i).eq.'=') ieq=i
        enddo
        if(cmd.eq.' ') goto 1
        if(isw.eq.0) goto 100
        if(isw.eq.30) goto 30
        if(isw.eq.40) goto 40
c get parameter name =========
 100    if(ieq.ne.0) then
           ieq1=ieq+1
           do i=ieq-1,1,-1
             if(cmd(i:i).ne.' ') then
               ieq=i
               goto 2
             endif
           enddo
    2      do i=1,ieq
             if(cmd(i:i).ne.' ') then
               ieb=i
               goto 3
             endif
           enddo
    3      pname=cmd(ieb:ieq)
           if(pname.eq.'nlayers')      goto 10
           if(pname.eq.'st_rk')        goto 20
           if(pname.eq.'rays')         goto 30
           if(pname.eq.'wavet')        goto 50
           if(pname.eq.'grid_size')    goto 60
           if(pname.eq.'model_cu')     goto 70
           if(pname.eq.'model_iasp')   goto 80
           if(pname.eq.'out_dir')      goto 90
           if(pname.eq.'h')           goto 110
c more switches ===============
           if(pname.eq.'coord')         goto 200
           if(pname.eq.'graph')         goto 210
           if(pname.eq.'debug')         goto 220
           if(pname.eq.'start_az')      goto 230
           if(pname.eq.'end_az')        goto 240
           if(pname.eq.'step_az')       goto 250
           if(pname.eq.'sta_name')      goto 260
           if(pname.eq.'sta_nick_name') goto 270
           if(pname.eq.'sta_lat')       goto 280
           if(pname.eq.'sta_lon')       goto 290
           if(pname.eq.'sta_elev')      goto 300
           if(pname.eq.'tables')        goto 310
           if(pname.eq.'delta')         goto 320
           if(pname.eq.'m_name')        goto 330

        l=lnblnk(pname)
        write(*,1010) pname(1:l)
        l=lnblnk(cmd)
        write(*,'("Context: <",a,">")') cmd(1:l)
 1010 format('(W010) Parameter ',a,' does not exists.')
        endif
        goto 1
c treat parameters ===================
   10   read(cmd(ieq1:160),*)nlayers
        goto 1 
   20   read(cmd(ieq1:160),*) st_rk
        st_rk=st_rk/2.0d0
        goto 1
   30   isw=30
        if(cmd.ne.'BEGIN') goto 1
        isw=40
        goto 1
   40   if(cmd.ne.'END') then
          read(cmd,*) lay_ind,igr,t_pn,t_sn,t_w,t_h
          igroup(lay_ind)=igr
          p_phname(lay_ind)=t_pn
          s_phname(lay_ind)=t_sn
          c_wave(lay_ind)=t_w
          c_head(lay_ind)=t_h
          goto 1
        else
          isw=0
          goto 1
        endif
   50   read(cmd(ieq1:160),*) wavet
        iwave=-1
        if(wavet(1:1).eq.'P') iwave=1
        goto 1
   60   read(cmd(ieq1:160),*) net
        dnet=net
        goto 1
   70   read(cmd(ieq1:160),*) model_cu
        goto 1
   80   read(cmd(ieq1:160),*) model_iasp
        goto 1
   90   read(cmd(ieq1:160),*) out_dir
        goto 1
c more paraneters ==============
  200   read(cmd(ieq1:160),*) coord
        igeoc=1
        if(coord.eq.'geoc') igeoc=0
        goto 1
  210   read(cmd(ieq1:160),*) igraph
        goto 1
  220   read(cmd(ieq1:160),*) idbg
        goto 1
  230   read(cmd(ieq1:160),*) iaz_i
        goto 1
  240   read(cmd(ieq1:160),*) iaz_e
        goto 1
  250   read(cmd(ieq1:160),*) iaz_st
        goto 1
  260   read(cmd(ieq1:160),*) sta_name
        goto 1
  270   read(cmd(ieq1:160),*) surr_name
        goto 1
  280   read(cmd(ieq1:160),*) sfi
        goto 1
  290   read(cmd(ieq1:160),*) slam
        goto 1
  300   read(cmd(ieq1:160),*) elev
        goto 1
  310   read(cmd(ieq1:160),*) tables
        goto 1
  320   read(cmd(ieq1:160),*) delta_max
        if(delta_max.lt.3.0d0.or.delta_max.gt.22.00001d0) then
            write(*,*) '(E102) delta=',delta_max,' , delta range is 3 - 20 degree'
            stop
        endif
        max_delta=(delta_max*rad*R0)/25.0d0 +2.0d0
        goto 1
  330   read(cmd(ieq1:160),*) m_name
        goto 1
  110   nhs= 0
c find the begin of digit ===========
  150   do j=ieq1,160
          do jj=j,160
            if(cmd(jj:jj).ne.' ') then
              ndg1=jj
              goto 130
            endif
          enddo
          goto 1
c find the begin of digit ===========
  130   do jj=ndg1,160
            if(cmd(jj:jj).eq.' ') then
              ndg2=jj
              goto 140
            endif
        enddo
      enddo
c digit is found !!! ===================
  140   nhs=nhs+1
        sdig=cmd(ndg1:ndg2)
        read(sdig,*)hs(nhs)
        ieq1=ndg2+1
        if(ieq1.gt.160) goto 1
        if(nhs.eq.10) goto 1
        goto 150
c parse record ===================================
   99 close(7)
c output current parameters ====================
      l=lnblnk(file_def)
      write(*,1020) file_def(1:l)
 1020 format('(I010) Parameter file: ',a,/,'Contents:')
 999  write(*,'("m_name=",a)') m_name
      write(*,'("nlayers=",i3)') nlayers
      write(*,'("st_rk=",f10.6)') st_rk*2.0d0
      write(*,'("grid_size=",i2)') net
      write(*,'("wavet=",a1)') wavet(1:1)
      write(*,'("coord=",a5,", debug=",i2,", graph=",i2,2x,i2)') coord,idbg,igraph,numb
      l=lnblnk(sta_name)
      l1=lnblnk(surr_name)
      write(*,1130) sta_name(1:l),surr_name(1:l1),sfi,slam,elev
 1130 format("sta_name=",a,", sta_nick_name=",a,",",/
     *"sta_lat=",f9.3,", sta_lon=",f9.3,", sta_elev=",f9.3)
      write(*,'("start=",i4,", end=",i4,", step=",i4)')iaz_i,iaz_e,iaz_st
      write(*,'("nhs =",i5,", h=",10f7.2)') nhs,(hs(l),l=1,nhs)
      write(*,'("delta=",f7.3,i5)') delta_max,max_delta
      l=lnblnk(tables)
      write(*,'("tables= ",a)') tables(1:l)
      l=lnblnk(model_cu)
      write(*,'("model_cu=",a)') model_cu(1:l)
      l=lnblnk(model_iasp)
      write(*,'("model_iasp=",a)') model_iasp(1:l)
      l=lnblnk(out_dir)
      write(*,'("model_out_dir=",a)') out_dir(1:l)
      write(*,'("rays=",/"BEGIN")') 
      do i =1,nlayers
        write(*,'(2i4,2x,a4,1x,a4,2x,a1,2x,a1)') i,igroup(i),
     *          p_phname(i),s_phname(i),c_wave(i),c_head(i)
      enddo
      write(*,'("END")') 
      do i =1,nlayers
        if(igroup(i).eq.-100) then
           stop '(E006) Wrong rays parameter definition'
        endif
      enddo
      return
 1000 format('(W001) Parameter file ',a,' does not exists.'/,
     *       '       Standard parameter values are assumed')
      end
c
c      character*160 aaa
c      aaa='par_file'
c      call set_defaults(aaa)
c      end
      subroutine group()
      implicit none
c --- Common blocks ---
      integer*4   nlayers,net,iwave,igroup(100)
      integer*4   nng,ngrno(100),ngrdev(100)
      real*8      st_rk,dnet
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet,nlayers,iwave,net,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c --- Type definition
      integer*4 i,igr
c ---
      do i=1,100    
        ngrdev(i)=-100
        name(i)='_'
      enddo
      nng=0
      do i=1,nlayers
        igr=igroup(i)
        if(igr.le.0.or.igr.gt.100) then
           write(*,*) 'Wrong group number'
           stop
        endif
        if(ngrdev(igr).eq.-100) then
          nng=nng+1
          ngrdev(igr)=nng
          ngrno(igr)=igroup(i)
          name(igr)=p_phname(i)
          if(iwave.lt.0) name(igr)=s_phname(i)
c         c_w(igr)=c_wave(i)
c         c_h(igr)=c_head(i)
c       else
c         if(c_w(igr).eq.'N') c_w(igr)=c_wave(i)
c         if(c_h(igr).eq.'N') c_h(igr)=c_head(i)
        endif
      enddo
      nng=0
      do i=1,100
       if(ngrdev(i).ne.-100) then
         nng=nng+1
         ngrno(nng)=ngrno(i)
         ngrdev(nng)=ngrdev(i)
         name(nng)=name(i)
         write(*,*) ngrno(nng),ngrdev(nng),' ',name(nng)
       endif
      enddo
      return
      end
c=============================================================
      subroutine lay_dev(lay,igrp,idev,ndev,fname,cc_w,cc_h)
      implicit none
c --- Common blocks ---
      integer*4   nlayers,net,iwave,ndev,igroup(100)
      integer*4   nng,ngrno(100),ngrdev(100)
      real*8      st_rk,dnet
      character*8 p_phname(100),s_phname(100),name(100)
      character*1 c_wave(100),c_head(100)
      common/prm/st_rk,dnet,nlayers,iwave,net,
     *nng,ngrno,ngrdev,name,
     *igroup,p_phname,s_phname,c_wave,c_head
c --- Type definition
      integer*4 lay,igrp,idev,i
      character*8 fname
      character*1 cc_w,cc_h
c ---
      igrp=igroup(lay)
      do i=1,nng
        if(igrp.eq.ngrno(i)) then
          idev=ngrdev(i)
          fname=name(i)
          cc_w=c_wave(lay)
          cc_h=c_head(lay)
cxx     write(*,*) lay,igrp,idev,fname,cc_w,cc_h
        endif
      enddo
      ndev=nng
      return
      end
