c********************************************************************
c     Two-point ray tracing
c xsour,zsour - source coordinates; tsour - starting time;
c dt - step; ac - accuracy; tmax - max time for step;
c itmax - numder of iterations; mout - print options;
c mdim =0, only time & rays; ncode - internal code;
c method - ==2, halfing interval; isour - starting layer;
c ltare - =0, data stored in formatted form;
c itpr - =0, receivers are located on the earth surface
c********************************************************************
      subroutine tramp(xsour,zsour,tsour,dt,ac,tmax,itmax,mout,
     1mdim,ncode,lou,method,isour,ltape,itpr,i_n,take_off)
      implicit none
c ---
      integer*4 n_int,n_intz,n_lay
      parameter (n_int=20,n_intz=50,n_lay=19)
c --- Common blocks -----------
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      real*8    ay,ds
      integer*4 kint,mreg,n,iref,ind,ind1
      common/ray/ay(12,10000),ds(11,50),kint(50),mreg,n,iref,ind,ind1
c ---
      real*8    dst,astart,astep,afin,reps,reps1,rstep
      integer*4 ndst,idist
      common/dist/dst(100),ndst,idist,astart,astep,afin,reps,reps1,rstep
c ---
      integer*4 code,kref,kc,k_beg,k_end,k_step,k_sig
      common/cod/code(50),kref,kc,k_beg,k_end,k_step,k_sig
c ---
      real*8    a1,b1,c1,d1,xx,brd
      integer*4 iii,npnt,nint
      common/intrf/a1(n_intz,n_int),b1(n_intz,n_int),c1(n_intz,n_int),
     *d1(n_intz,n_int),xx(n_intz,n_int),brd(2),iii(n_intz,n_int),
     *npnt(n_int),nint
c ---
      real*8    qp1,qp2,qp3,qs1,qs2,qs3
      integer*4 nqp,nqs,nabs
      common/absr/qp1(n_lay),qp2(n_lay),qp3(n_lay),qs1(n_lay),qs2(n_lay),
     *qs3(n_lay),nqp(n_lay),nqs(n_lay),nabs
c ---
      integer*4 intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
      common/auxi/intr,int1,iout,kre,irefr,lay,itype,nder,iprint,mprint,ntr,imet
c ---
      integer*4 ksh,nsh
      common/sh/ksh,nsh
c ---
      integer*4 i_g,i_gg
      real*8    t_min,t_min3,r_max
      common/tbl/i_g,i_gg,t_min(100,11,3),t_min3(100,3),r_max(100,11,3)
c ---
      real*8    sl6(4500),vmoh(4500)
      common/sl/sl6,vmoh
c ---
      real*8    xvsp
      integer*4 icod,ivsp
      common/vsp/xvsp,icod,ivsp
c ---
      integer*4 idbg,iaz_i,iaz_e,iaz_st,iaz_c,igraph,igrc,igeoc,npid
      real*8    azi,sfi,slam,elev
      character*8 sta_name,surr_name,tables
      character*8 spid
      common/all/azi,sfi,slam,elev,spid,idbg,iaz_i,iaz_e,iaz_st,iaz_c,
     *sta_name,surr_name,tables,igraph,igrc,igeoc,npid
c --- Type definitions ---
      integer*4 ifail5
      integer*4 i,i1,i2,i_a,i_n,in1,in2,isour,itmax,itpr,j,l,lou
      integer*4 ltape,mdim,method,mout,ncode,indic,ibr,iflag
      integer*4 nk(10),n_old(10),ll,nng
      real*8    r_max1,r_max2,t_end,dd3,dd4,tt3,tt4,fl1,fl2
      real*8    take_off(20),ddm,ttm,dray,dste,coef,wpar
      real*8    aa1,aa2,aam,ac,dd1,dd2,dt,fi,tt1,tt2
      real*8    step,step0,stepf,t,tmax,tsour,x,xsour,z,zsour
      real*8    e_x1,e_x2,e_z1,e_z2,e_t1,e_t2,e_xc,e_zc,e_tc
      integer*4 igrp
      character*8 fname
      character*1 cc_w,cc_h
c ---
      i_a=iabs(kref/2)
      itype=isign(1,code(1))
      call lay_dev(i_a,igrp,i_g,nng,fname,cc_w,cc_h)
      if(cc_w.eq.'N') return
      if(cc_h.eq.'Y'.and.i_a.eq.1) kc=0
      ifail5=0
      if(idbg.gt.0) then
        do i=1,i_n
           write(*,*) 'take_off',iaz_c,i,take_off(i)
        enddo
        write(*,*)'Code:',kref,kc,(code(l),l=1,kref),' ccw= ',cc_w,' cch ',cc_h
        write(*,*) 'iiiaaa',iaz_c,i_a,take_off(i_a)
      endif
c     Estimate initial step ==============================
      aa1=take_off(i_a)
      step0=0.0005d0
      step=step0
      if(i_a.eq.1) then
        aa2=0.0001
        dray=20.0d0
        goto 67
      endif
 777  aa2=aa1
c Find initial ray with index: +-8, +-9, -3 =======================
   11 ind=isour
      call ray2(xsour,zsour,tsour,aa1,x,z,t,fi,tmax,dt,ac)
c**   call print_ray
      if(ind.eq.3.and.ind1.lt.0) ind=-3
      if(ind.eq.3) ind=-9
      if(ind.eq.8.and.iabs(ind1).gt.i_a) ind=-8
      if(ind.eq.2.and.iabs(ind1).ge.i_a) ind=-2
      if(idbg.gt.0) then
        z=r0*(1.0d0-dexp(-z/r0))
        write(*,*)'ini',t,x,z,aa1,ind,ind1
      endif
      if(iabs(ind).eq.8) then
         if(ind.gt.0) then
           aa1=aa1+step0/10.0d0
         else
           aa1=aa1-step0/10.0d0
         endif
           aa2=aa1
           goto 11
      endif
c Move across 8 or 9 layer in positive direction =========================
      step=step0
      in1=ind
      in2=ind
      tt1=ay(1,n)
      tt2=tt1
      if(in1.eq.9.or.in1.eq.8.or.in1.eq.2) then
    1   aa2=aa1+step
        ind=isour
        call ray2(xsour,zsour,tsour,aa2,x,z,t,fi,tmax,dt,ac)
c**   call print_ray
        if(ind.eq.3.and.ind1.lt.0) ind=-3
        if(ind.eq.3) ind=-9
        if(ind.eq.8.and.iabs(ind1).gt.i_a) ind=-8
        if(ind.eq.2.and.iabs(ind1).ge.i_a) ind=-2
        if(idbg.gt.0) then
          z=r0*(1.0d0-dexp(-z/r0))
          write(*,*)'down:',t,x,z,aa2,ind,ind1
        endif
        dd2=ay(2,n)
        in2=ind
        tt2=ay(2,n)
        if(in2.eq.9.or.in2.eq.8.or.in2.eq.2) then
          aa1=aa2
          in1=in2
          dd1=dd2
          tt1=tt2
        dste=dabs(dd1-dd2)/25.0d0
        if(dste.lt.0.9d0) dste=0.9d0
        if(dste.gt.1.1d0) dste=1.1d0
        step=step/dste
          goto 1
        endif
c Move aross 3 layer in negative direction or just 1 step for -3 layer
      else if(in2.eq.-3.or.in2.eq.-9.or.in2.eq.-8.or.in2.eq.-2) then
    2   aa1=aa2-step
        ind=isour
        call ray2(xsour,zsour,tsour,aa1,x,z,t,fi,tmax,dt,ac)
c**   call print_ray
        if(ind.eq.3.and.ind1.lt.0) ind=-3
        if(ind.eq.3) ind=-9
        if(ind.eq.8.and.iabs(ind1).gt.i_a) ind=-8
        if(ind.eq.2.and.iabs(ind1).ge.i_a) ind=-2
        if(idbg.gt.0) then
          z=r0*(1.0d0-dexp(-z/r0))
          write(*,*)'up:',t,x,z,aa1,ind,ind1
        endif
        dd1=ay(2,n)
        tt1=ay(1,n)
        in1=ind
        if(in1.eq.-3.or.in1.eq.-9.or.in1.eq.-8.or.in1.eq.-2) then
          dd2=dd1
          aa2=aa1
          in2=in1
          tt2=tt1
        dste=dabs(dd1-dd2)/25.0d0
        if(dste.lt.0.9d0) dste=0.9d0
        if(dste.gt.1.1d0) dste=1.1d0
        step=step/dste
          goto 2
        endif
      else
       write(*,'("(E668) Confused situation,up-down: lay=",i3,", ind=",i3,", 
     *        ind1=")') i_a,ind,ind1
       if(ind.eq.5.and.ifail5.eq.0) then
         aa1=aa1+0.00005d0
         ifail5=1
         goto 777
       endif
           stop
      endif
      if(idbg.gt.0) write(*,*) 'up-down',aa1,dd1,in1,aa2,dd2,in2
c Half division methods for the best upper initial point approximation ======
    4 aam=(aa1+aa2)/2.0d0
      ind=isour
      call ray2(xsour,zsour,tsour,aam,x,z,t,fi,tmax,dt,ac)
c**   call print_ray
        if(ind.eq.3.and.ind1.lt.0) ind=-3
        if(ind.eq.3) ind=-9
        if(ind.eq.8.and.iabs(ind1).gt.i_a) ind=-8
        if(ind.eq.2.and.iabs(ind1).ge.i_a) ind=-2
        if(idbg.gt.0) then
          z=r0*(1.0d0-dexp(-z/r0))
          write(*,*)'half div:',t,x,z,aam,ind,ind1
        endif
      if(dabs(aa2-aa1).le.1.d-8) goto 5
      if(ind.eq.-3.or.ind.eq.-8.or.ind.eq.-9.or.ind.eq.-2) then
        aa2=aam
        in2=ind
        dd2=ay(2,n)
        tt2=ay(1,n)
        goto4
      else
        aa1=aam
        in1=ind
        dd1=ay(2,n)
        tt1=ay(1,n)
        goto4
      endif
    5 continue
      ind=isour
      call ray2(xsour,zsour,tsour,aa2,x,z,t,fi,tmax,dt,ac)
      if(ind.eq.3.and.ind1.lt.0) ind=-3
      in2=ind
      aam=aa2
      if(idbg.gt.0) write(*,*) 'catch:',aa1,dd1,in1,aa2,dd2,in2
      if(idbg.gt.0) write(*,*) 'catch:',aa2,ay(1,n),ay(2,n),ay(3,n)
      if(i_a.lt.i_n) take_off(i_a)=aa2
c
c Produce main result for layer ===============================
c
      dray=20.0d0
      if(in2.ne.-3) then 
         write(*,'("(W669) Layer not found: lay=",i3,", inds=",2i3)')i_a,in1,in2
         dray=50.0d0
cxx      if(i_a.eq.6) goto 67
cxx      goto 66
      endif
  67  step=0.5d-7
cxx   if(i_a.ge.6) step=1.5d-7
      stepf=step
      aam=aa2
      write(lou,*) 'angles:',i_a,take_off(i_a),aa2
      if(cc_h.eq.'Y') then
         ind=isour
         call ray2(xsour,zsour,tsour,aam,x,z,t,fi,tmax,dt,ac)
      call refract(i_a,dt,ac,tmax)
         lay=isour
         int1=isour
         intr=isour
      endif
      fl2=0.0d0
      dd4=0.0d0
      tt4=0.0d0
  66  indic=0
      r_max2=0.0d0
      iflag=0
      goto 16
  6   aa1=aam
      if(iflag.eq.0) then
         aam=aam+step
      else
         step=step*1.2d0
         if(step.gt.stepf) step=stepf
         aam=aam+step
      endif
  16  dd1=dd2
      fl1=fl2
      tt1=tt2    
      dd3=dd4
      tt3=tt4
      r_max1=r_max2
      ind=isour
      call ray2(xsour,zsour,tsour,aam,x,z,t,fi,tmax,dt,ac)
        if(i_a.eq.1.and.ind.eq.3.and.aam.lt.0.3d0) ind=-3
        if(ind.eq.3.and.ind1.lt.0) ind=-3
        if(ind.eq.-3.and.igraph.gt.0) call plot_ray(0,i_a,t,x,z,aam)
        if(ind.eq.3.and.igraph.gt.1) call plot_ray(1,i_a,t,x,z,aam)
      dd2=ay(2,n)
      tt2=ay(1,n)
c* find intersection with the 3 layer ==================
      dd4=dd2
      tt4=tt2
      ll=kint(iref-2)
      if(ll.gt.0) then
         dd4=ay(2,ll)
         tt4=ay(1,ll)
      endif
      aa2=aam
      if(idbg.gt.0) write(*,*)'main0',i_a,(ay(l,n),l=1,3),aam,ind,ind1
      if(ind.eq.-3.and.iflag.eq.1) then
         goto 66
      endif
      if(iflag.eq.0.and.ind.eq.-3) goto 8
      if(iflag.eq.1.and.aam.gt.t_end+0.1d-7) goto 7
      if(iflag.eq.1.and.aam.gt.t_end+0.1d-7.and.i_a.eq.i_n.and.x.gt.0.0d0) goto 18
  17  if(iflag.eq.1) goto 18
      iflag=1
      if(i_a.lt.i_n) t_end=take_off(i_a+1)
      if(i_a.lt.i_n-1) t_end=dmax1(take_off(i_a+2),take_off(i_a+1))
      if(i_a.eq.i_n) t_end=pi/2.0d0
      stepf=dabs(t_end-aam)/dray
      goto 18
c Find turning point of the ray
   8  continue
  18  r_max2=-30.0d0
1118  format(f12.5,2i3,2f12.5,2i3)
      do i=2,nhs
        nk(i)=0
        n_old(i)=0
      enddo
      do i=2,n
        e_z1=ay(3,i-1)
        e_z2=ay(3,i)
        e_x1=ay(2,i-1)
        e_x2=ay(2,i)
        e_t1=ay(1,i-1)
        e_t2=ay(1,i)
        do j=2,nhs
        if(nk(j).ge.1.and.iflag.ne.0) goto 77
          e_zc=h(j)
          ibr=-1
          if(e_zc.gt.e_z1.and.e_zc.le.e_z2.and.nk(j).eq.0) ibr=0
          if(e_zc.gt.e_z2.and.e_zc.le.e_z1.and.iflag.eq.0) then
             ibr=i_a
             n_old(j)=i
             goto 77
          endif
          if(ibr.ge.0) then
            if(dabs(e_z2-e_z1).lt.1.0e-8) then
             e_xc=(e_x2+e_x1)/2.0d0
            else
             e_xc=(e_x2-e_x1)/(e_z2-e_z1)*(h(j)-e_z1)+e_x1
            endif
            if(dabs(e_x2-e_x1).lt.1.0e-8) then
             e_tc=(e_t2+e_t1)/2.0d0
            else
             e_tc=(e_t2-e_t1)/(e_x2-e_x1)*(e_xc-e_x1)+e_t1
            endif
            if(r_max2.gt.e_zc) e_zc=r_max2
            e_zc=r0*(1.0d0-dexp(-e_zc/r0))
            e_z2=r0*(1.0d0-dexp(-e_z2/r0))
            e_z1=r0*(1.0d0-dexp(-ay(3,n)/r0))
    
            write(30+nng+1,'(f5.1,i4,f11.5,f12.5,2f11.5,f11.5,f15.10,i6)')
     *       hs(j),i_g,e_tc,e_xc,e_zc,e_z2,e_z1,aam,n
          nk(j)=nk(j)+1
          endif
   77   continue
        enddo
       if(e_z2.gt.r_max2) r_max2=e_z2
      enddo
c Output left side ============================================
      do j=2,nhs
        if(n_old(j).eq.0) goto 88
        i=n_old(j)
        e_zc=h(j)
        e_z1=ay(3,i-1)
        e_z2=ay(3,i)
        e_x1=ay(2,i-1)
        e_x2=ay(2,i)
        e_t1=ay(1,i-1)
        e_t2=ay(1,i)
        ibr=i_a
            if(dabs(e_z2-e_z1).lt.1.0e-8) then
             e_xc=(e_x2+e_x1)/2.0d0
            else
             e_xc=(e_x2-e_x1)/(e_z2-e_z1)*(h(j)-e_z1)+e_x1
            endif
            if(dabs(e_x2-e_x1).lt.1.0e-8) then
             e_tc=(e_t2+e_t1)/2.0d0
            else
             e_tc=(e_t2-e_t1)/(e_x2-e_x1)*(e_xc-e_x1)+e_t1
            endif
            if(r_max2.gt.e_zc) e_zc=r_max2
            e_zc=r0*(1.0d0-dexp(-e_zc/r0))
            e_z2=r0*(1.0d0-dexp(-e_z2/r0))
            e_z1=r0*(1.0d0-dexp(-ay(3,n)/r0))
   
            write(30+i_g,'(f5.1,i4,f11.5,f12.5,2f11.5,f11.5,f15.10,i6)')
     *       hs(j),ibr+100,e_tc,e_xc,e_zc,e_z2,e_z1,aam,n
   88   continue
      enddo
c Main branch ==================================================
      if(iflag.eq.1) goto 6
      r_max2=r0*(1.0d0-dexp(-r_max2/r0))
      if(idbg.gt.0) write(*,*)'main1',i_a,(ay(l,n),l=1,3),aam,r_max2,ind,ind1
      z=r0*(1.0d0-dexp(-z/r0))
      write(lou,1113)i_a,azi,t,x,z,aam,r_max2,ind,ind1,n
      if(indic.eq.0) then
        r_max1=r_max2
        fl1=fl2
        dd3=dd4
        tt3=tt4
        indic=1
        goto 6
      endif
      if(iflag.eq.0) then
          coef=dabs(dd1-dd2)/25.0d0
          if(coef.lt.0.8d0)coef=0.8d0
          if(coef.gt.6.0d0)coef=6.0d0
        if(dabs(dd1-dd2).lt.25.0d0) then
          step=step/coef 
        else 
          step=step/coef 
        endif
        if(step.lt.0.5d-7) step = 0.5d-7
      endif
c Estimate minimal time for Surface ============================
cxx   if(i_a.lt.i_n) take_off(i_a+1)=aam
      i1=dd1/25.0d0
      i2=dd2/25.0d0
c**   if(dd2.le.dd1) goto 6
      do i=i1,i2
      if(i.gt.max_delta) goto 666
      ddm=dble(i)*25.0d0
        if(dd1.le.ddm.and.ddm.le.dd2) then
          ttm=(tt2-tt1)*(ddm-dd1)/(dd2-dd1)+tt1
          if(dabs(t_min(i+1,1,i_g)).gt.ttm) then
             t_min(i+1,1,i_g)=ttm
             wpar=(r_max2-r_max1)*(ddm-dd1)/(dd2-dd1)+r_max1
             r_max(i+1,1,i_g)=r0*(1.0d0-dexp(-wpar/r0))
          endif
        endif
      enddo
c Estimate minimal time for third layer ============================
c**   write(*,*) tt3,tt4,dd3,dd4
666   i1=dd3/25.0d0
      i2=dd4/25.0d0
c**   if(dd4.le.dd3) goto 6
      do i=i1,i2
      if(i.gt.max_delta) goto 6
      ddm=dble(i)*25.0d0
        if(dd3.le.ddm.and.ddm.le.dd4) then
          ttm=(tt4-tt3)*(ddm-dd3)/(dd4-dd3)+tt3
          if(dabs(t_min3(i+1,i_g)).gt.ttm) then
             t_min3(i+1,i_g)=ttm
          endif
        endif
      enddo
      goto 6
  7   t_min(1,1,i_g)=0.0d0
      t_min3(1,i_g)=0.0d0
      r_max(1,1,i_g)=0.0d0
c Extract fixed table for depthes=0,10,...,50
      if(cc_h.eq.'Y'.and.i_a.eq.1) kc=1
      return
 1113 format('ppp  ',1x,i3,4f12.5,2f15.10,2i3,i6)
 1114 format(3f12.5,i3,2f12.5,f15.10,f12.5)
  108 format(2i5)
  109 format(2e15.5) 
      end
