c============================================================
c  Program conv_model . Author M.P.Barmin, Date: 02/23/01
c  conv_model coverts full CU 3D model to input data model
c  format for D2tracersc program
c============================================================
      implicit none
      character*160 in_file,out_file
c --- common's ---
      integer*4 n_prof,n_lay,mind,ind,mnn
      real*4    gmod,gff,gfl
      common/model/ n_prof,n_lay,mind(100),ind(100),
     *gmod(100,20000,3),gff(20000),gfl(20000),mnn(20000)
c ---
      integer n,iargc
      n=iargc()
      if(n.ne.2) stop 'Usage: conv_model in_model out_model'
      call getarg(1,in_file)
      call getarg(2,out_file)
      CALL RD3D(in_file,out_file)
      write(*,*) '# vertical grid=',n_prof,', #layers=',n_lay
      call system('rm tmp.tmp.1')
      end
c============================================================
c Program rd3d . Author M.P.Barmin, Date: 02/23/01
c Model range: 0-670 CU, 670-2892 iasp91
c============================================================
      SUBROUTINE RD3D(file_cu,file_out)
      implicit none
      character*160 file_cu,file_out
c --- common's ---
      integer*4 n_prof,n_lay,mind,ind,mnn
      real*4    gmod,gff,gfl
      common/model/ n_prof,n_lay,mind(100),ind(100),
     *gmod(100,20000,3),gff(20000),gfl(20000),mnn(20000)
c ---
      integer*4 n_ak
      real*4 grd_ak(3,27)
      common/data/n_ak,grd_ak
c -- 
      integer*4 i,idum,idumm1,idumm2,iff,ifl,iflag,ilay,
     *          ind_strt,j,jj,jjj,k,ll,nvel
      real*4    dum1,dumm1,flag
      integer*4 itab(179,361),imind(2)
      real*4    zgmod(3),vp_av(200),vs_av(200)
      do i=1,179
      do j=1,361
        itab(i,j)=0
      enddo
      enddo
      call aver_mod(file_cu)
c* Read average velocities 1 --> 171, 2 --> 170, etc
      open(10,file='tmp.tmp.1',form='formatted',status='OLD')
      read(10,*) nvel
      do i=1,nvel
        read(10,*) idumm1,idumm2,dumm1,vp_av(i),vs_av(i)
      enddo
      close(10)
c* Read CU MODEL
      open(7,file=file_cu,form='formatted',status='OLD')
      i=0
    2 i=i+1
c* Read profile head ----------------------
      read(7,*,end=99) gff(i),gfl(i),mnn(i)

c	write(*,*) i, gff(i),gfl(i),mnn(i)

      iff=gff(i)+90.5
      if(gfl(i).lt.0.0) gfl(i)=gfl(i)+360.0
      ifl=gfl(i)+2.5
      itab(iff,ifl)=i
      if(ifl.eq.361) itab(iff,1)=i
c Read layers -------------------------------
      ind_strt=167
      jj=0
      do jjj=1,mnn(i)
      read(7,*,end=99)
     *idum,imind(2),zgmod(1),zgmod(3),dum1,zgmod(2)

c	write(*,*) i, jj, jjj, idum,imind(2),zgmod(1),zgmod(3),dum1,zgmod(2)

      imind(1)=jjj
c* skip ocean & sea & ice
      if(imind(2).eq.171.or.imind(2).eq.170) goto 3
      if(imind(2).eq.169.or.imind(2).eq.168) goto 3
   4  if(ind_strt.eq.imind(2)) then
      jj=jj+1
       mind(jj)=imind(2)
       gmod(jj,i,1)=zgmod(1)
       gmod(jj,i,2)=zgmod(2)
       gmod(jj,i,3)=zgmod(3)
       ind_strt=ind_strt-1
       goto 3
      else
       if(jj.eq.0) then
         jj=jj+1
         mind(jj)=imind(2)
         gmod(jj,i,1)=zgmod(1)
         gmod(jj,i,2)=vp_av(jj+4)
         gmod(jj,i,3)=vs_av(jj+4)
         ind_strt=ind_strt-1
         jj=jj+1
         mind(jj)=imind(2)
	 zgmod(1) = zgmod(1)+.0001
         gmod(jj,i,1)=zgmod(1)
         gmod(jj,i,2)=vp_av(jj+4)
         gmod(jj,i,3)=vs_av(jj+4)
         ind_strt=ind_strt-1
         goto 4
       endif
       jj=jj+1
       mind(jj)=ind_strt
       gmod(jj,i,1)=gmod(jj-1,i,1)
       gmod(jj,i,2)=vp_av(jj+4)
       gmod(jj,i,3)=vs_av(jj+4)
       ind_strt=ind_strt-1
       jj=jj+1
       mind(jj)=ind_strt
       gmod(jj,i,1)=gmod(jj-1,i,1)+0.0001
       zgmod(1) = zgmod(1) + 0.0001 
       gmod(jj,i,2)=vp_av(jj+4)
       gmod(jj,i,3)=vs_av(jj+4)
       ind_strt=ind_strt-1
       goto 4
      endif
    3 continue
      enddo
* Add AK135 +================================================
      do k=1,n_ak
      jj=jj+1
      mind(jj)=ind_strt
      gmod(jj,i,1)=grd_ak(1,k)
      gmod(jj,i,2)=grd_ak(2,k)
      gmod(jj,i,3)=grd_ak(3,k)
      ind_strt=ind_strt-1
      enddo
      mnn(i)=jj
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      goto 2
   99 close(7)
      n_prof=i-1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      open(9,file=file_out,form='formatted',status='UNKNOWN')
      do i=1,n_prof
c write data ======================================
      write(9,'(f12.4,f11.4,i4)')gff(i),gfl(i),mnn(i)-1
        k=1
        iflag=0
   5    ilay=168-k
        if(ilay.eq.125) flag=1
        if(ilay.ne.124) write(9,'(2i4,5f10.4)') k-iflag,ilay-iflag,
     *  (gmod(k,i,ll),ll=1,3)
        k=k+1
        if(k.le.mnn(i)) goto 5
 100  continue
      enddo
      close(9)
      do i=1,n_prof-1
cxx   write(*,*) gff(i),gfl(i),mnn(i)
      enddo
      n_lay=mnn(1)
      return
      end
c*========================================================
c Construct average CU Model
c*========================================================
      subroutine aver_mod(file_cu)
      implicit none
c ---
      character*160 file_cu
      integer*4 imind(100,2),nnn(200)
      integer*4 i,i_i,ic,jj,jjj,mnn,n,idum
      real*4    zgmod(100,3)
      real*4    dep(200),vp(200),vs(200),wgt(200)
      real*4    dum1,gff,gfl,rad,vpvs,wn
c ---
      rad=atan(1.)/45.
      do i=1,200
        nnn(i)=0
        wgt(i)=0.0
        dep(i)=0.0
        vp(i)=0.0
        vs(i)=0.0
       enddo
      open(7,file=file_cu,form='formatted',status='old')
      open(8,file='tmp.tmp.1',form='formatted',status='unknown')
      i=0
    2 i=i+1
c* Read profile head ----------------------
      read(7,*,end=99) gff,gfl,mnn
      do jj=1,mnn
      read(7,*,end=99)
     *idum,imind(jj,2),zgmod(jj,1),zgmod(jj,3),dum1,zgmod(jj,2)
      imind(jj,1)=jjj
      i_i=imind(jj,2)
      nnn(i_i)=1
      wn=COS(gff*rad)
      wgt(i_i)=wgt(i_i)+wn
      dep(i_i)=dep(i_i)+zgmod(jj,1)*wn
      vp(i_i)=vp(i_i)+zgmod(jj,2)*wn
      vs(i_i)=vs(i_i)+zgmod(jj,3)*wn
      enddo
      goto 2
   99 close(7)
c average model ===================
      n=0
      do i=200,1,-1
        if(nnn(i).ne.0) n=n+1
      enddo
      write(8,'(i4)') n
      ic=0
      do i=200,1,-1
       if(nnn(i).ne.0) then
         ic=ic+1
         dep(i)=dep(i)/wgt(i)
         vp(i)=vp(i)/wgt(i)
         vs(i)=vs(i)/wgt(i)
         vpvs=0.0
         if(vs(i).gt.0.01) vpvs=vp(i)/vs(i)
         write(8,'(2i4,4f10.4)') ic,i,dep(i),vp(i),vs(i),vpvs
       endif
      enddo
      close(8)
      return
      end
c=================================================
      BLOCK DATA AK135
      implicit none
c ---
      integer*4 n_ak
      real*4 grd_ak(3,27)
      common/data/n_ak,grd_ak
c --- Acually this is IASP91 model
      data n_ak/27/,grd_ak
     */710.00, 10.9229, 6.0797,
     * 760.00, 11.0558, 6.2095,
     * 809.50, 11.1440, 6.2474,
     * 859.00, 11.2300, 6.2841,
     * 908.50, 11.3140, 6.3199,
     * 958.00, 11.3960, 6.3546,
     *1007.50, 11.4761, 6.3883,
     *1057.00, 11.5543, 6.4211,
     *1106.50, 11.6308, 6.4530,
     *1156.00, 11.7055, 6.4841,
     *1205.50, 11.7787, 6.5143,
     *1255.00, 11.8504, 6.5438,
     *1403.50, 12.0568, 6.6280,
     *1502.50, 12.1881, 6.6809,
     *1601.50, 12.3151, 6.7317,
     *1651.00, 12.3772, 6.7564,
     *1700.50, 12.4383, 6.7807,
     *1750.00, 12.4987, 6.8046,
     *1898.50, 12.6759, 6.8745,
     *1997.50, 12.7915, 6.9199,
     *2146.00, 12.9625, 6.9870,
     *2294.50, 13.1325, 7.0540,
     *2393.50, 13.2462, 7.0991,
     *2492.50, 13.3610, 7.1449,
     *2542.00, 13.4189, 7.1681,
     *2690.50, 13.5961, 7.2398,
     *2740.00, 13.6564, 7.2645/
      end
