c======================================================
c iasp91_tbl.f program create IASP91_TBL reference file
c for D2tracerdn programm for P and S waves separately. 
c Output file IASP_TBL includes 3 parts for Pg,Pn,P or
c Lg,Sn,S. Each part consists of header - 1 line and
c 2 D table - 91 lines. Header format correspond to SSSC's
c header format, but fields mostly have no sence, except 
c the last one - phase name. The table includs
c 13 columns. The first column is a distance (km),
c columns 2-7 represent IASP91 travel time for the depths
c 0, 10, 20, 30, 40, 50, columns 8 -13 are the
c station correction coefficients in the same order as time.
c This coefficients are not used currently.
c======================================================
      implicit none
c --- Common block definitions ---
      real*8    geo,r0,pi,rad,h(10),hs(10)
      integer*4 nhs,max_delta
      common/const/geo,r0,pi,rad,h,hs,nhs,max_delta
c ---
      character*160 model_cu,model_iasp,out_dir
      common/fnames/ model_cu,model_iasp,out_dir
c ---
      integer *4 i,i1,i2,k,l,ll,ierr,n,iargc,ixx
      real*4     del,t,dtd,vel0,wor,tab(10),tab1(10),hss
      character*8 p_hc,p_name,phase(6),phase_o(6),iasp,m_name
      character*160 file_out,par_name
      character*20 wavet
c
c correct depths if you'd like, the first depth shoul be
c zero.
c
cxx   data hs/0.0,10.0,20.0,30.0,40.0,50.0/
      data phase/'Pg','Pn','P','Sg','Sn','S'/
      data phase_o/'Pg','Pn','P','Lg','Sn','S'/
      iasp='IASP'
      r0=6371.0d0
      rad=datan(1.0d0)/45.0d0

      n=iargc()
      if(n.ne.1) stop 'Usage: iasp91_tbl parameter_file'
      call getarg(1,par_name)
      p_name='P'
      wavet=p_name
      call set_defaults(par_name,wavet,m_name)
c The first depth should be zero !!! -------------------
      hs(1)=0.0
c write data ========================
      file_out=model_iasp
      open(7,file=file_out,status='unknown')
      do ixx=1,2
      if(ixx.eq.1) p_name='P'
      if(ixx.eq.2) p_name='S'
      p_hc='P+'
      i1=1
      i2=3
      if(p_name.eq.'S') then
        p_hc='S+'
        i1=4
        i2=6
      endif
      do i=i1,i2
      write(7,1000) 0.0,0.0,0.0,0.0,nhs,max_delta,iasp,iasp,phase_o(i)
      write(7,1001) (hs(l),l=1,nhs)
      do k=1,max_delta+1
        del=(k-1)*25.0
          do l=1,nhs
            tab(l)=9999.999
            tab1(l)=9999.999
            hss=hs(l)
            if(p_name.eq.'S') then
              call time_iasp91s(phase(i),p_hc,del,hss,t,dtd,ierr)
            else
              call time_iasp91p(phase(i),p_hc,del,hss,t,dtd,ierr)
            endif
            if(ierr.eq.0) then
              tab(l)=t
              tab1(l)=dtd
c             if(abs(dtd).gt.20.0) tab1(l)=9999.999
            endif
          enddo
c
c correction coefficients for the station elevation correction
c coefficients = full_correction / sta_elevation
c
         do ll=1,nhs
           if(tab(ll).lt.9000.0) then
             vel0=5.8
             if(p_name.eq.'S') vel0=3.36
             wor=vel0/tab1(ll)
             if(wor.gt.1.0) then
               stop 'ERRRRROR !!!!'
             endif
             tab1(ll)=sqrt(1.0-wor*wor)/vel0
           endif
         enddo
          write(7,2000) del,(tab(l),l=1,nhs),(tab1(l),l=1,nhs)
        enddo
      enddo
      enddo
      close(7)
 1000 format(4f12.5,2i5,1x,a8,1x,a8,1x,a8)
 1001 format(f7.1,9f9.3)
 2000 format(f7.1,20f9.3)
      end
