c=================================================================o
c University of Colorado, Phys. Dept., CIEI                       o
c Program pr_sssc_n v1.1, Created: 19/02/2001                     o
c          Author: M.P.Barmin                                     o
c          Phone: (303) 735-1850                                  o
c          Fax:   (303) 492-7935                                  o
c          Email: barmin@colorado.edu                             o
c Program pr_sssc_n convert SSSC's second depth to geographical   o
c cooordinates and output on stdout  xyz GMT grid.                o
c Usage: pr_sssc sta_name phase sssc_dir mod_nam                  o
c Input:                                                          o
c    sta_name  - station code                                     o
c    phase     - phase name: Pg, Pn, P, Lg, Sn or S               o
c    sssc_dir   - absolute or relative (from running              o
c                directory) path to SSSCs directory               o
c    mod_nam   - input model name (part of SSSC name).            o
c                Full SSSC's name is: sta_nam.phase.mod_name.dat  o
c Output:                                                         o
c        Write on stdout GMT xyz grid                             o
c=================================================================o
      implicit none
      real*8    geo,r0,pi,rad
      common/const/geo,r0,pi,rad
c ---
      real*8    t(120,121),fff(20),fll(20),depth
      real*8    delta,ff,fl,azi,hh,drad,d1,dum1(3),hh,hhh(20),elev,res(20)
      integer*4 i,j,k,ij,k,l,m,narg,n,n1,n2,n3,nhs,max_delta
      integer*4 iargc,lnblnk
      character*4   sta,phase
      character*160 in_file,tt_dir,mod_nam
c ---
      narg=iargc()
      if(narg.ne.5) stop 'Usage: pr_sssc_n sta_name phase depth sssc_dir mod_nam'
      CALL getarg(1,sta)
      CALL getarg(2,phase)
      CALL getarg(3,tt_dir)
      read(tt_dir,*) depth
      CALL getarg(4,tt_dir)
      CALL getarg(5,mod_nam)
      geo=0.993277d0
      r0=6371.0d0
      pi=datan(1.0d0)*4.0d0
      rad=pi/180.0d0
      drad=rad*6371.0d0
      m=3
      n=lnblnk(sta)
      n1=lnblnk(tt_dir)
      n2=lnblnk(phase)
      n3=lnblnk(mod_nam)
      in_file=tt_dir(1:n1)//'/'//sta(1:n)//'.'//phase(1:n2)//'.'//
     *         mod_nam(1:n3)//'.dat'
      open(7,file=in_file,status='old')
      do j=1,120
      read(7,*)azi,ff,fl,elev,nhs,max_delta
      read(7,*) (hhh(l),l=1,nhs)
      do i=1,max_delta+1
        read(7,*,end=9) hh,dum1(1),(res(l),dum1(2),l=1,nhs)
	  k=0
          do ij=2,nhs
            if(depth.ge.hhh(ij-1).and.depth.le.hhh(ij)) then
		k=ij-1
		goto 2
            endif
	  enddo
	  write(*,*) 'Wrong depth = ',depth, ', program conv_cu_idc aborted'
    2	  if(res(k+1).gt.9000.0.or.res(k).gt.9000.0) then
             t(j,i)=0.0
             goto 3
	  endif
        t(j,i)=(res(k+1)-res(k))/(hhh(k+1)-hhh(k))*(depth-hhh(k))+res(k)
    3   delta=hh/drad
        call path_az(delta,ff,fl,azi,d1,m,fff,fll)
        write(*,'(3f12.4)')fll(3),fff(3),t(j,i)
      enddo
      enddo
   9  close(7)
      end
